<?php

namespace Util;

interface Query {

    // Using IDCLIUTSITE
    /*const GET_CLIENTS = "
        SELECT CF.CDCLIENTE, CF.CDFILIAL,
               DECODE(CL.IDEXBTPNOMECLIE,'F', CL.NMFANTCLIE, CL.NMRAZSOCCLIE) AS NMFANTCLIE
          FROM CLIENTE CL, CLIENFILIAL CF
         WHERE CL.CDCLIENTE = CF.CDCLIENTE
           AND CF.IDPERMVENDAFOS = 'S'
           AND CF.IDCLIUTSITE = 'S'
         ORDER BY CL.NMFANTCLIE, CL.NMRAZSOCCLIE
    ";*/

    // Using IDFILUTSITE
    const GET_CLIENTS = "
      SELECT PA.CDCLIENTE, PA.CDFILIAL,
          DECODE(CL.IDEXBTPNOMECLIE,'F', CL.NMFANTCLIE, CL.NMRAZSOCCLIE) AS NMFANTCLIE
      FROM CLIENTE CL, PARAVEND PA, CLIENFILIAL CF
      WHERE PA.CDCLIENTE = CL.CDCLIENTE
        AND PA.CDFILIAL = CF.CDFILIAL
        AND PA.CDCLIENTE = CF.CDCLIENTE
        AND CF.IDPERMVENDAFOS = 'S'
        AND PA.IDFILUTSITE = 'S'
      ORDER BY CL.NMFANTCLIE, CL.NMRAZSOCCLIE
    ";

    const GET_CLIENTS_WITH_FILTER = "
      SELECT PA.CDCLIENTE, PA.CDFILIAL,
          DECODE(CL.IDEXBTPNOMECLIE,'F', CL.NMFANTCLIE, CL.NMRAZSOCCLIE) AS NMFANTCLIE
      FROM CLIENTE CL, PARAVEND PA, CLIENFILIAL CF
      WHERE PA.CDCLIENTE = CL.CDCLIENTE
        AND PA.CDFILIAL = CF.CDFILIAL
        AND PA.CDCLIENTE = CF.CDCLIENTE
        AND CF.IDPERMVENDAFOS = 'S'
        AND PA.IDFILUTSITE = 'S'
        AND UPPER(CL.NMFANTCLIE) LIKE UPPER(:NMFANTCLIE)
      ORDER BY CL.NMFANTCLIE, CL.NMRAZSOCCLIE
    ";

    const GET_CONSUMER_BY_LOGIN_CLIENTLESS = "
        SELECT C.CDCLIENTE, C.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDSENHACONSMD5,
               C.NMLOGINCONS, C.DSEMAILCONS, CF.CDFILIAL, C.CDTIPOCONS,
               C.NRCPFRESPCON, C.NMRESPCONS,
               DECODE(CL.IDEXBTPNOMECLIE,'F', CL.NMFANTCLIE, CL.NMRAZSOCCLIE) AS NMFANTCLIE
          FROM CONSUMIDOR C, CLIENTE CL, CLIENFILIAL CF
         WHERE UPPER(C.NMLOGINCONS) = UPPER(:NMLOGINCONS)
           AND C.CDCLIENTE = CL.CDCLIENTE
           AND C.IDSITCONSUMI = '1'
           AND CF.CDCLIENTE = C.CDCLIENTE
           AND CF.IDPERMVENDAFOS = 'S'
           AND CF.IDCLIUTSITE = 'S'
    ";

    const GET_CONSUMER_BY_LOGIN = "
        SELECT C.CDCLIENTE, C.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDSENHACONSMD5,
               C.NMLOGINCONS, C.DSEMAILCONS, CL.NMFANTCLIE, C.CDTIPOCONS,
               C.NRCPFRESPCON, C.NMRESPCONS
          FROM CONSUMIDOR C, CLIENTE CL
         WHERE C.CDCLIENTE = :CDCLIENTE
           AND UPPER(C.NMLOGINCONS) = UPPER(:NMLOGINCONS)
           AND C.CDCLIENTE = CL.CDCLIENTE
           AND C.IDSITCONSUMI = '1'
    ";

    const GET_CONSUMER_BY_ID = "
        SELECT C.CDCLIENTE, C.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDSENHACONSMD5,
               C.NMLOGINCONS, C.DSEMAILCONS, CL.NMFANTCLIE, C.CDTIPOCONS,
               C.NRCPFRESPCON, C.NMRESPCONS
          FROM CONSUMIDOR C, CLIENTE CL
         WHERE C.CDCLIENTE = :CDCLIENTE
           AND C.CDIDCONSUMID = :CDIDCONSUMID
           AND C.CDCLIENTE = CL.CDCLIENTE
           AND C.IDSITCONSUMI = '1'
    ";
    
    const GET_CONSUMER_BY_EMAIL = "
        SELECT C.CDCLIENTE, C.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDSENHACONSMD5,
               C.NMLOGINCONS, C.DSEMAILCONS, CL.NMFANTCLIE, C.CDTIPOCONS,
               C.NMRESPCONS, C.NRCPFRESPCON
          FROM CONSUMIDOR C, CLIENTE CL
         WHERE C.CDCLIENTE = :CDCLIENTE
           AND UPPER(C.DSEMAILCONS) = UPPER(:DSEMAILCONS)
           AND C.CDCLIENTE = CL.CDCLIENTE
           AND C.IDSITCONSUMI = '1'
    ";

    const GET_CONSUMER_BY_NAME = "
        SELECT C.CDCLIENTE, C.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDSENHACONSMD5,
               C.NMLOGINCONS, C.DSEMAILCONS, CL.NMFANTCLIE, C.CDTIPOCONS,
               C.NRCPFRESPCON, C.NMRESPCONS
          FROM CONSUMIDOR C, CLIENTE CL
         WHERE C.CDCLIENTE = :CDCLIENTE
           AND C.CDCONSUMIDOR = :CDCONSUMIDOR
           AND C.CDCLIENTE = CL.CDCLIENTE
           AND C.IDSITCONSUMI = '1'
    ";

    const GET_CONSUMER_BY_PARENT = "
        SELECT C.CDCLIENTE, C.CDSENHACONSMD5, C.NMLOGINCONS, C.NMCONSUMIDOR,
               C.DSEMAILCONS, CL.NMFANTCLIE, C.CDTIPOCONS, C.CDCONSUMIDOR,
               C.NRCPFRESPCON, C.NMRESPCONS,
               TO_CHAR((NVL(SUM(SC.VRSALDCONFAM), 0)), 'FM999G999G990D90', 'nls_numeric_characters='',.''') AS VRSALDCONFAM
          FROM CONSUMIDOR C JOIN CLIENTE CL
                              ON C.CDCLIENTE = CL.CDCLIENTE

                            JOIN TIPOCONS TC
                              ON C.CDTIPOCONS = TC.CDTIPOCONS

                       LEFT JOIN (SELECT * FROM SALDOCONS SC
                                    JOIN FAMSALDOFILI FS
                                      ON FS.CDFAMILISALD = SC.CDFAMILISALD
                                   WHERE FS.CDFILIAL = :CDFILIAL) SC
                              ON C.CDCLIENTE = SC.CDCLIENTE
                             AND C.CDCONSUMIDOR = SC.CDCONSUMIDOR

         WHERE C.CDCLIENTE = :CDCLIENTE
           AND C.NRCPFRESPCON = :NRCPFRESPCON
           AND C.IDSITCONSUMI = '1'
           AND TC.IDUTRECARGAAPP = 'S'
        GROUP BY C.CDCLIENTE, C.CDSENHACONSMD5, C.NMLOGINCONS, C.NMCONSUMIDOR,
                 C.DSEMAILCONS, CL.NMFANTCLIE, C.CDTIPOCONS, C.CDCONSUMIDOR,
                 C.NRCPFRESPCON, C.NMRESPCONS
    ";

    const GET_FILIAL_DATA = "
        SELECT F.NMFILIAL, F.NMRAZSOCFILI, F.NRINSJURFILI
          FROM FILIAL F
         WHERE F.CDFILIAL = :CDFILIAL
    ";

    const GET_FILIAL_ENDE = "
        SELECT EF.SGESTADO, M.NMMUNICIPIO, EF.DSENDEFILI, EF.NMBAIRFILI,
               EF.DSEMAILFILI, EF.CDPAIS
          FROM ENDEFILI EF, MUNICIPIO M
         WHERE EF.CDFILIAL = :CDFILIAL
            AND EF.CDMUNICIPIO = M.CDMUNICIPIO
    ";

    const INSERT_PEDICREDCONS = "
        INSERT INTO PEDICREDCONS
        (NRPEDCRECONS, VRPEDCRECONS, DTPEDCRECONS, IDPEDCREEXTR,
         IDPEDCRECONT, CDCLIENTE, CDCONSUMIDOR, NRBOLETO)
        VALUES
        (:NRPEDCRECONS, :VRPEDCRECONS, SYSDATE, :IDPEDCREEXTR,
         :IDPEDCRECONT, :CDCLIENTE, :CDCONSUMIDOR, :NRBOLETO)
    ";

    const INSERT_PEDICREDFAMI = "
        INSERT INTO PEDICREDFAMI
        (NRPEDCRECONS, CDFAMILISALD, VRPEDCREFAMI)
        VALUES
        (:NRPEDCRECONS, :CDFAMILISALD, :VRPEDCREFAMI)
    ";

    const GET_BALANCE = "
        SELECT FS.CDFAMILISALD, FS.NMFAMILISALD, SC.VRSALDCONFAM
          FROM FAMILIASALDO FS JOIN SALDOCONS SC
                                 ON SC.CDFAMILISALD = FS.CDFAMILISALD
                               JOIN FAMSALDOFILI FF
                                 ON FF.CDFAMILISALD = FS.CDFAMILISALD
         WHERE SC.CDCLIENTE = :CDCLIENTE
           AND SC.CDCONSUMIDOR = :CDCONSUMIDOR
           AND FF.CDFILIAL = :CDFILIAL
           AND FF.IDPERMCARGACRED = 'S'
    ";
    
    const GET_BALANCE_LOGIN = "
        SELECT FS.CDFAMILISALD, FS.NMFAMILISALD, SC.VRSALDCONFAM
          FROM FAMILIASALDO FS JOIN SALDOCONS SC
                                 ON SC.CDFAMILISALD = FS.CDFAMILISALD
         WHERE SC.CDCLIENTE = :CDCLIENTE
           AND SC.CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const CHECK_BALANCE = "
        SELECT VRSALDCONFAM
          FROM SALDOCONS
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
    ";

    const CREATE_BALANCE = "
        INSERT INTO SALDOCONS
            (CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRSALDCONFAM)
        VALUES
            (:CDCLIENTE, :CDCONSUMIDOR, :CDFAMILISALD, :VRSALDCONFAM)
    ";

    const GET_CONSUMERS_BALANCE = "
        SELECT CO.CDCLIENTE, CO.CDCONSUMIDOR, SUM(SC.VRSALDCONFAM) AS SALDOTOTAL
          FROM SALDOCONS SC JOIN CONSUMIDOR CO
                              ON SC.CDCLIENTE = CO.CDCLIENTE
                             AND SC.CDCONSUMIDOR = CO.CDCONSUMIDOR

         WHERE CO.CDCLIENTE = :CDCLIENTE
           AND CO.NRCPFRESPCON = :NRCPFRESPCON

        GROUP BY CO.CDCLIENTE, CO.CDCONSUMIDOR
    ";


    const GET_RECHARGE_GRID = "
    SELECT C.NMCONSUMIDOR, C.CDCONSUMIDOR, C.NRCPFRESPCON, NULL AS CDFAMILISALD, C.NMCONSUMIDOR AS NMFAMILISALD,
             NULL AS VRSALDCONFAM, C.CDCONSUMIDOR AS PRIMARY, NULL AS PARENT
      FROM CONSUMIDOR C
      JOIN TIPOCONS TC
        ON C.CDTIPOCONS = TC.CDTIPOCONS
      WHERE C.CDCLIENTE  = :CDCLIENTE
        AND C.NRCPFRESPCON = :NRCPFRESPCON
        AND C.IDSITCONSUMI = '1'
        AND TC.IDUTRECARGAAPP = 'S'
    UNION
    SELECT NULL AS NMCONSUMIDOR, NULL AS CDCONSUMIDOR, NULL AS NRCPFRESPCON, FS.CDFAMILISALD,
             FS.NMFAMILISALD, '0,00' AS VRSALDCONFAM, TAB.CDCONSUMIDOR || '_' || FS.CDFAMILISALD AS PRIMARY,
             TAB.CDCONSUMIDOR AS PARENT
      FROM FAMSALDOFILI FF
      JOIN FAMILIASALDO FS
        ON FS.CDFAMILISALD = FF.CDFAMILISALD,
             (SELECT C.NMCONSUMIDOR, C.CDCONSUMIDOR, C.NRCPFRESPCON, NULL AS CDFAMILISALD, NULL AS NMFAMILISALD,
                   NULL AS VRSALDCONFAM
                FROM CONSUMIDOR C
                JOIN TIPOCONS TC
                  ON C.CDTIPOCONS = TC.CDTIPOCONS
                WHERE C.CDCLIENTE  = :CDCLIENTE
                  AND C.NRCPFRESPCON = :NRCPFRESPCON
                  AND C.IDSITCONSUMI = '1'
                  AND TC.IDUTRECARGAAPP = 'S'
              ) TAB
      WHERE FF.CDFILIAL = :CDFILIAL
        AND FF.IDPERMCARGACRED = 'S'
    ";

    const INSERT_TRANSACAO = "
        INSERT INTO TRANSACAO
            (NRTRANSACAO, DSTRANSACAO, DTTRANSACAO, CDCLIENTE,
            CDCONSUMIDOR, NRNIT, VRMOVEXTCONS, NRORG, IDATIVO)
        VALUES
            (:NRTRANSACAO, :DSTRANSACAO, SYSDATE, :CDCLIENTE,
            :CDCONSUMIDOR, :NRNIT, :VRMOVEXTCONS, 1, 'S')
    ";

    const INSERT_TRANSACAOCONS = "
        INSERT INTO TRANSACAOCONS
            (NRTRANSACAO , CDCLIENTE, CDCONSUMIDOR, NRORG, IDATIVO)
        VALUES
            (:NRTRANSACAO , :CDCLIENTE, :CDCONSUMIDOR, 1, 'S')
    ";

    const UPDATE_TRANSACAO = "
        UPDATE TRANSACAO
        SET DSTRANSACAO = :DSTRANSACAO,
            NRNIT = :NRNIT
        WHERE NRTRANSACAO = :NRTRANSACAO
    ";

    const INSERT_CRED_LOG = "
        INSERT INTO LOGOPERAVND
            (NMTABELAVND, DTOPERACAOVND, NMRESPOPERVND, CDPESQITEMVND,
             IDTIPOOPERVND, DSOPERACAOVND, NRORG, IDATIVO)
        VALUES
            (:NMTABELAVND, SYSDATE, :NMRESPOPERVND, :CDPESQITEMVND,
             :IDTIPOOPERVND, :DSOPERACAOVND, :NRORG, :IDATIVO)
    ";

    const GET_UNRESTRICTED_FAMILIES = "
        SELECT FS.CDFAMILISALD, FS.NMFAMILISALD, '0,00' AS VRSALDCONFAM
          FROM FAMSALDOFILI FF JOIN FAMILIASALDO FS
                                 ON FS.CDFAMILISALD = FF.CDFAMILISALD
         WHERE FF.CDFILIAL = :CDFILIAL
           AND FF.CDFAMILISALD NOT IN (SELECT CDFAMILISALD
                                         FROM RALIMENT
                                        WHERE CDFILIAL = :CDFILIAL
                                          AND CDCLIENTE = :CDCLIENTE
                                          AND CDCONSUMIDOR = :CDCONSUMIDOR
                                          AND VRCONSDIARAL IS NOT NULL)
    ";

    const GET_CARD_STATUS = "
        SELECT IDSITCONSUMI
          FROM CONSUMIDOR
         WHERE CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDCLIENTE = :CDCLIENTE
    ";

    const TOGGLE_CARD_BLOCK = "
        UPDATE CONSUMIDOR
           SET IDSITCONSUMI = :IDSITCONSUMI
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const GET_CLIENT_NAME = "
        SELECT DECODE(IDEXBTPNOMECLIE,'F', NMFANTCLIE, NMRAZSOCCLIE) AS NMFANTCLIE
          FROM CLIENTE
         WHERE CDCLIENTE = :CDCLIENTE
    ";

    const GET_CONSUMER_DETAILS = "
        SELECT CS.CDCLIENTE, CS.CDCONSUMIDOR, CS.NMCONSUMIDOR, CS.NRCPFRESPCON,
               PA.NMPAIS, ES.SGESTADO, MU.NMMUNICIPIO, CS.DSENDECONS,
               CS.NMBAIRCONS, CS.NRCEPCONS, CS.NRTELECONS, CS.NRTELE2CONS,
               CS.NRCELULARCONS, BA.NMBAIRRO, CS.NRENDECONS, CS.DSCOMPLENDECONS,
               CS.DSEMAILCONS, CS.IDSEXOCONS, CS.DSREFERENDECONS, CS.CDPAIS,
               CS.CDMUNICIPIO, CS.DTNASCCONS, BA.CDBAIRRO, CS.NMRESPCONS,
               MU.CDDDDMUNICIP, CS.HABENVNOTIF, CS.HABENVEMAIL, CS.CDTIPOCONS
          FROM CONSUMIDOR CS LEFT JOIN PAIS PA
                                    ON PA.CDPAIS = CS.CDPAIS

                             LEFT JOIN ESTADO ES
                                    ON ES.CDPAIS = CS.CDPAIS
                                   AND ES.SGESTADO = CS.SGESTADO

                             LEFT JOIN MUNICIPIO MU
                                    ON MU.CDMUNICIPIO = CS.CDMUNICIPIO
                                   AND MU.SGESTADO = ES.SGESTADO
                                   AND MU.CDPAIS = ES.CDPAIS

                             LEFT JOIN BAIRRO BA
                                    ON BA.CDBAIRRO = CS.CDBAIRRO
                                   AND BA.CDMUNICIPIO = MU.CDMUNICIPIO
                                   AND BA.SGESTADO = MU.SGESTADO
                                   AND BA.CDPAIS = MU.CDPAIS
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const GET_CONSUMER_SONS = "
        SELECT NMCONSUMIDOR, CDCONSUMIDOR
        FROM CONSUMIDOR
        WHERE CDCLIENTE = :CDCLIENTE
        AND NRCPFRESPCON = :NRCPFRESPCON
    ";

    const GET_EXTRACT = "
        WITH SLDOA AS
        (
        	SELECT  E.CDCLIENTE
        	       ,E.CDCONSUMIDOR
        	       ,E.CDFAMILISALD
        	       ,E.DTMOVEXTCONS
        	       ,E.VRSALDCONEXT AS SALDANT
        	FROM EXTRATOCONS E,
        	(
        		SELECT  E.CDCLIENTE
        		       ,E.CDCONSUMIDOR
        		       ,E.CDFAMILISALD
        		       ,MAX(E.DTMOVEXTCONS) AS DTMOVEXTCONS
        		FROM EXTRATOCONS E, CONSUMIDOR C
        		WHERE C.CDCLIENTE = :P_CDCLIENTE
        		AND C.CDCONSUMIDOR = :P_CDCONSUMIDOR
        		AND E.CDCLIENTE = C.CDCLIENTE
        		AND E.CDCONSUMIDOR = C.CDCONSUMIDOR
        		AND TRUNC(TO_DATE(E.DTMOVEXTCONS)) < TO_DATE(:P_DTEXTRATOINI, 'DD/MM/YYYY')
        		GROUP BY  E.CDCLIENTE
        		         ,E.CDCONSUMIDOR
        		         ,E.CDFAMILISALD
        	) D
        	WHERE E.CDCLIENTE = D.CDCLIENTE
        	AND E.CDCONSUMIDOR = D.CDCONSUMIDOR
        	AND E.CDFAMILISALD = D.CDFAMILISALD
        	AND E.DTMOVEXTCONS = D.DTMOVEXTCONS 
        )
        SELECT  FS.CDFAMILISALD
               ,FS.NMFAMILISALD                                                                         AS IDPAI
               ,EX.DTMOVEXTCONS                                                                         AS DATAMOVEXT
               ,EX.CDCLIENTE || EX.CDCONSUMIDOR || EX.CDFAMILISALD || EX.DTMOVEXTCONS || EX.NRSEQMOVEXT AS ID
               ,EX.VRSALDCONEXT                                                                         AS SALDODISP
               ,TO_CHAR(EX.DTMOVEXTCONS,'DD/MM/YY')                                                     AS DTMOVEXTCONS
               ,DECODE( EX.IDTPMOVEXT,'V',NVL( TRUNC( SUM( ( (IV.QTPRODVEND * IV.VRUNITVEND) + IV.VRACRITVEND - IV.VRDESITVEND ) ),2 ),EX.VRMOVEXTCONS ),EX.VRMOVEXTCONS ) AS MOVIMENTACAO
               ,SLDOA.SALDANT
               ,EX.IDTPMOVEXT                                                                           AS IDTPMOVEXT
               ,'- ' || DECODE( EX.IDTPMOVEXT,'V',TO_CHAR(SUM(IV.QTPRODVEND)) || 'x ' || PR.NMPRODUTO,EX.DSOPEEXTCONS ) DSMOVIMENTACAO
               ,'N'                                                                                     AS PARENT
        FROM CLIENTE CLI, FAMILIASALDO FS, CONSUMIDOR C, EXTRATOCONS EX, TIPOCONS T, TIPOCONSCLI TC, VENDA VE, SERVICO SE, ITEMVENDA IV, PRODUTO PR, SLDOA
        WHERE C.CDCLIENTE = :P_CDCLIENTE
        AND C.CDCONSUMIDOR = :P_CDCONSUMIDOR
        AND EX.CDCLIENTE = C.CDCLIENTE
        AND EX.CDCLIENTE = CLI.CDCLIENTE
        AND EX.CDCONSUMIDOR = C.CDCONSUMIDOR
        AND EX.CDFAMILISALD = FS.CDFAMILISALD
        AND EX.CDFAMILISALD = IV.CDFAMILISALD
        AND C.CDTIPOCONS = T.CDTIPOCONS
        AND EX.CDCONSUMIDOR = SLDOA.CDCONSUMIDOR (+)
        AND EX.CDFAMILISALD = SLDOA.CDFAMILISALD (+)
        AND C.CDCLIENTE = TC.CDCLIENTE (+)
        AND C.CDTIPOCONS = TC.CDTIPOCONS (+)
        AND VE.CDSERVFILI = SE.CDSERVFILI (+)
        AND VE.CDFILIAL = SE.CDFILIAL (+)
        AND EX.CDCLIENTE = VE.CDCLIENTE (+)
        AND EX.CDCONSUMIDOR = VE.CDCONSUMIDOR (+)
        AND EX.CDFILIAL = VE.CDFILIAL (+)
        AND EX.CDCAIXA = VE.CDCAIXA (+)
        AND EX.NRSEQVENDA = VE.NRSEQVENDA (+)
        AND VE.CDFILIAL = IV.CDFILIAL (+)
        AND VE.CDCAIXA = IV.CDCAIXA (+)
        AND VE.NRSEQVENDA = IV.NRSEQVENDA (+)
        AND IV.CDPRODUTO = PR.CDPRODUTO (+)
        AND ( TRUNC(TO_DATE(EX.DTMOVEXTCONS)) BETWEEN TO_DATE(:P_DTEXTRATOINI, 'DD/MM/YYYY') AND TO_DATE(:P_DTEXTRATOFIN, 'DD/MM/YYYY') )
        GROUP BY  FS.CDFAMILISALD
                 ,FS.NMFAMILISALD
                 ,EX.VRMOVEXTCONS
                 ,EX.VRSALDCONEXT
                 ,TO_CHAR(EX.DTMOVEXTCONS,'DD/MM/YY')
                 ,EX.DTMOVEXTCONS
                 ,'DD/MM/YY'
                 ,EX.DTMOVEXTCONS
                 ,EX.CDCLIENTE || EX.CDCONSUMIDOR || EX.CDFAMILISALD || EX.DTMOVEXTCONS || EX.NRSEQMOVEXT
                 ,EX.CDCONSUMIDOR
                 ,EX.CDFAMILISALD
                 ,EX.DTMOVEXTCONS
                 ,EX.NRSEQMOVEXT
                 ,SLDOA.SALDANT
                 ,EX.IDTPMOVEXT
                 ,DECODE( EX.IDTPMOVEXT,'V',TO_CHAR(IV.QTPRODVEND) || 'x ' || PR.NMPRODUTO,EX.DSOPEEXTCONS )
                 ,EX.IDTPMOVEXT
                 ,'V'
                 ,TO_CHAR(IV.QTPRODVEND) || 'x ' || PR.NMPRODUTO
                 ,IV.QTPRODVEND
                 ,'x '
                 ,PR.NMPRODUTO
                 ,EX.DSOPEEXTCONS
                 ,'N'
        UNION
        SELECT  FS.CDFAMILISALD
               ,FS.NMFAMILISALD                                                                                                   AS IDPAI
               ,EX.DTMOVEXTCONS                                                                                                   AS DATAMOVEXT
               ,EX.CDCLIENTE || EX.CDCONSUMIDOR || EX.CDFAMILISALD || EX.DTMOVEXTCONS || EX.NRSEQMOVEXT                           AS ID
               ,EX.VRSALDCONEXT                                                                                                   AS SALDODISP
               ,TO_CHAR(EX.DTMOVEXTCONS,'DD/MM/YY')                                                                               AS DTMOVEXTCONS
               ,ROUND(EX.VRMOVEXTCONS,2)                                                                                          AS MOVIMENTACAO
               ,SLDOA.SALDANT
               ,EX.IDTPMOVEXT                                                                                                     AS IDTPMOVEXT
               ,TO_CHAR(EX.DTMOVEXTCONS,'DD/MM/YY') || DECODE( EX.IDTPMOVEXT,'C',' - CRÉDITO','V',' - VENDA','D',' - DÉBITO','' ) AS DSMOVIMENTACAO
               ,'S'                                                                                                               AS PARENT
        FROM EXTRATOCONS EX, FAMILIASALDO FS, SLDOA
        WHERE EX.CDCLIENTE = :P_CDCLIENTE
        AND EX.CDCONSUMIDOR = :P_CDCONSUMIDOR
        AND EX.CDFAMILISALD = FS.CDFAMILISALD
        AND ( TRUNC(TO_DATE(EX.DTMOVEXTCONS)) BETWEEN TO_DATE(:P_DTEXTRATOINI, 'DD/MM/YYYY') AND TO_DATE(:P_DTEXTRATOFIN, 'DD/MM/YYYY') )
        AND EX.CDCONSUMIDOR = SLDOA.CDCONSUMIDOR (+)
        AND EX.CDFAMILISALD = SLDOA.CDFAMILISALD (+)
        ORDER BY 1, 3, 2, 11 DESC
    ";

    const GET_PRODUCT_GROUPS = "
        SELECT NMGRUPPROD, CDGRUPPROD,  to_char(SUM(MOVIMENTACAO), 'fm9999999.90')  AS VRTOTALPROD
          FROM (
                SELECT PR.CDPRODUTO, PR.NMPRODUTO,
                       NVL(GP.NMGRUPPROD, 'OUTROS') AS NMGRUPPROD, GP.CDGRUPPROD,
                       NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMSUBGRPROD, SP.CDSUBGRPROD,
                       TO_CHAR(EC.DTMOVEXTCONS, 'dd/mm/yy') AS DTMOVEXTCONS, TRUNC(EC.DTMOVEXTCONS) AS DATA,
                       ((IV.QTPRODVEND * (IV.VRUNITVEND - IV.VRDESITVEND + IV.VRACRITVEND))) AS MOVIMENTACAO,
                       EC.IDTPMOVEXT
                  FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                       PRODUTO PR LEFT JOIN NVSUBGRPROD SG ON SG.CDPRODUTO = PR.CDPRODUTO
                                  LEFT JOIN SUBGRUPPROD SP ON SP.CDSUBGRPROD = SG.CDSUBGRPROD
                                                          AND SP.CDGRUPPROD = SG.CDGRUPPROD
                                  LEFT JOIN GRUPPROD GP ON GP.CDGRUPPROD = SG.CDGRUPPROD
                 WHERE EC.CDCLIENTE = :CDCLIENTE
                   AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                   AND EC.IDTPMOVEXT = 'V'
                   AND EC.CDFAMILISALD = FS.CDFAMILISALD
                   AND EC.CDFILIAL = IV.CDFILIAL
                   AND EC.CDCAIXA = IV.CDCAIXA
                   AND EC.NRSEQVENDA = IV.NRSEQVENDA
                   AND IV.CDPRODUTO = PR.CDPRODUTO
                   AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
               )
         GROUP BY NMGRUPPROD, CDGRUPPROD
    ";

    const GET_PRODUCT_SUBGROUPS = "
        SELECT NMSUBGRPROD, CDGRUPPROD, CDSUBGRPROD, to_char(SUM(MOVIMENTACAO), 'fm9999999.90')  AS VRTOTALPROD
          FROM (
                SELECT PR.CDPRODUTO, PR.NMPRODUTO,
                       NVL(GP.NMGRUPPROD, 'OUTROS') AS NMGRUPPROD, GP.CDGRUPPROD,
                       NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMSUBGRPROD, SP.CDSUBGRPROD,
                       TO_CHAR(EC.DTMOVEXTCONS, 'dd/mm/yy') AS DTMOVEXTCONS, TRUNC(EC.DTMOVEXTCONS) AS DATA,
                       ((IV.QTPRODVEND * (IV.VRUNITVEND - IV.VRDESITVEND + IV.VRACRITVEND))) AS MOVIMENTACAO,
                       EC.IDTPMOVEXT
                  FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                       PRODUTO PR LEFT JOIN NVSUBGRPROD SG ON SG.CDPRODUTO = PR.CDPRODUTO
                                  LEFT JOIN SUBGRUPPROD SP ON SP.CDSUBGRPROD = SG.CDSUBGRPROD
                                                          AND SP.CDGRUPPROD = SG.CDGRUPPROD
                                  LEFT JOIN GRUPPROD GP ON GP.CDGRUPPROD = SG.CDGRUPPROD
                 WHERE EC.CDCLIENTE = :CDCLIENTE
                   AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                   AND EC.IDTPMOVEXT = 'V'
                   AND EC.CDFAMILISALD = FS.CDFAMILISALD
                   AND EC.CDFILIAL = IV.CDFILIAL
                   AND EC.CDCAIXA = IV.CDCAIXA
                   AND EC.NRSEQVENDA = IV.NRSEQVENDA
                   AND IV.CDPRODUTO = PR.CDPRODUTO
                   AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
               )
         WHERE NVL(CDGRUPPROD, 'NULL') = :CDGRUPPROD
         GROUP BY NMSUBGRPROD, CDGRUPPROD, CDSUBGRPROD
    ";

    const GET_PRODUCTS = "
        SELECT NMPRODUTO, CDPRODUTO, CDGRUPPROD, CDSUBGRPROD, to_char(SUM(MOVIMENTACAO), 'fm9999999.90')  AS VRTOTALPROD
          FROM (
                SELECT PR.CDPRODUTO, PR.NMPRODUTO,
                       NVL(GP.NMGRUPPROD, 'OUTROS') AS NMGRUPPROD, GP.CDGRUPPROD,
                       NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMSUBGRPROD, SP.CDSUBGRPROD,
                       TO_CHAR(EC.DTMOVEXTCONS, 'dd/mm/yy') AS DTMOVEXTCONS, TRUNC(EC.DTMOVEXTCONS) AS DATA,
                       ((IV.QTPRODVEND * (IV.VRUNITVEND - IV.VRDESITVEND + IV.VRACRITVEND))) AS MOVIMENTACAO,
                       EC.IDTPMOVEXT
                  FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                       PRODUTO PR LEFT JOIN NVSUBGRPROD SG ON SG.CDPRODUTO = PR.CDPRODUTO
                                  LEFT JOIN SUBGRUPPROD SP ON SP.CDSUBGRPROD = SG.CDSUBGRPROD
                                                          AND SP.CDGRUPPROD = SG.CDGRUPPROD
                                  LEFT JOIN GRUPPROD GP ON GP.CDGRUPPROD = SG.CDGRUPPROD
                 WHERE EC.CDCLIENTE = :CDCLIENTE
                   AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                   AND EC.IDTPMOVEXT = 'V'
                   AND EC.CDFAMILISALD = FS.CDFAMILISALD
                   AND EC.CDFILIAL = IV.CDFILIAL
                   AND EC.CDCAIXA = IV.CDCAIXA
                   AND EC.NRSEQVENDA = IV.NRSEQVENDA
                   AND IV.CDPRODUTO = PR.CDPRODUTO
                   AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
               )
         WHERE NVL(CDGRUPPROD, 'NULL') = :CDGRUPPROD
           AND NVL(CDSUBGRPROD, 'NULL') = :CDSUBGRPROD
         GROUP BY NMPRODUTO, CDPRODUTO, CDGRUPPROD, CDSUBGRPROD
    ";

    const GET_GROUP_QUANTITY = "
        SELECT NMGRUPPROD, CDGRUPPROD, COUNT(CDGRUPPROD) AS VRTOTALPROD
          FROM (
                SELECT PR.CDPRODUTO, PR.NMPRODUTO,
                       NVL(GP.NMGRUPPROD, 'OUTROS') AS NMGRUPPROD, GP.CDGRUPPROD,
                       NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMSUBGRPROD, SP.CDSUBGRPROD,
                       TO_CHAR(EC.DTMOVEXTCONS, 'dd/mm/yy') AS DTMOVEXTCONS, TRUNC(EC.DTMOVEXTCONS) AS DATA,
                       ((IV.QTPRODVEND * (IV.VRUNITVEND - IV.VRDESITVEND + IV.VRACRITVEND))) AS MOVIMENTACAO,
                       EC.IDTPMOVEXT
                  FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                       PRODUTO PR LEFT JOIN NVSUBGRPROD SG ON SG.CDPRODUTO = PR.CDPRODUTO
                                  LEFT JOIN SUBGRUPPROD SP ON SP.CDSUBGRPROD = SG.CDSUBGRPROD
                                                          AND SP.CDGRUPPROD = SG.CDGRUPPROD
                                  LEFT JOIN GRUPPROD GP ON GP.CDGRUPPROD = SG.CDGRUPPROD
                 WHERE EC.CDCLIENTE = :CDCLIENTE
                   AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                   AND EC.IDTPMOVEXT = 'V'
                   AND EC.CDFAMILISALD = FS.CDFAMILISALD
                   AND EC.CDFILIAL = IV.CDFILIAL
                   AND EC.CDCAIXA = IV.CDCAIXA
                   AND EC.NRSEQVENDA = IV.NRSEQVENDA
                   AND IV.CDPRODUTO = PR.CDPRODUTO
                   AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
               )
         WHERE CDGRUPPROD IS NOT NULL
         GROUP BY NMGRUPPROD, CDGRUPPROD

         UNION

        SELECT NMGRUPPROD, CDGRUPPROD, COUNT(*) - COUNT(CDGRUPPROD) AS VRTOTALPROD
          FROM (
                SELECT PR.CDPRODUTO, PR.NMPRODUTO,
                       NVL(GP.NMGRUPPROD, 'OUTROS') AS NMGRUPPROD, GP.CDGRUPPROD,
                       NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMSUBGRPROD, SP.CDSUBGRPROD,
                       TO_CHAR(EC.DTMOVEXTCONS, 'dd/mm/yy') AS DTMOVEXTCONS, TRUNC(EC.DTMOVEXTCONS) AS DATA,
                       ((IV.QTPRODVEND * (IV.VRUNITVEND - IV.VRDESITVEND + IV.VRACRITVEND))) AS MOVIMENTACAO,
                       EC.IDTPMOVEXT
                  FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                       PRODUTO PR LEFT JOIN NVSUBGRPROD SG ON SG.CDPRODUTO = PR.CDPRODUTO
                                  LEFT JOIN SUBGRUPPROD SP ON SP.CDSUBGRPROD = SG.CDSUBGRPROD
                                                          AND SP.CDGRUPPROD = SG.CDGRUPPROD
                                  LEFT JOIN GRUPPROD GP ON GP.CDGRUPPROD = SG.CDGRUPPROD
                 WHERE EC.CDCLIENTE = :CDCLIENTE
                   AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                   AND EC.IDTPMOVEXT = 'V'
                   AND EC.CDFAMILISALD = FS.CDFAMILISALD
                   AND EC.CDFILIAL = IV.CDFILIAL
                   AND EC.CDCAIXA = IV.CDCAIXA
                   AND EC.NRSEQVENDA = IV.NRSEQVENDA
                   AND IV.CDPRODUTO = PR.CDPRODUTO
                   AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
               )
         WHERE CDGRUPPROD IS NULL
         GROUP BY NMGRUPPROD, CDGRUPPROD
    ";

    const GET_INITIAL_SALDO = "
        SELECT EC.VRSALDCONEXT
          FROM EXTRATOCONS EC
         WHERE EC.CDCLIENTE = :CDCLIENTE
           AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
           AND EC.DTMOVEXTCONS = (SELECT MIN(EC.DTMOVEXTCONS) AS DTMOVEXTCONS
                                    FROM EXTRATOCONS EC
                                   WHERE EC.CDCLIENTE = :CDCLIENTE
                                     AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                                     AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy')))
    ";

    const GET_PERIOD_CREDITS = "
        SELECT SUM(EC.VRMOVEXTCONS) TOTALCREDITOS
          FROM EXTRATOCONS EC
         WHERE EC.IDTPMOVEXT = 'C'
           AND EC.CDCLIENTE = :CDCLIENTE
           AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
           AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
    ";

    const GET_PERIOD_DEBITS = "
        SELECT SUM(EC.VRMOVEXTCONS) TOTALCREDITOS
          FROM EXTRATOCONS EC
         WHERE EC.IDTPMOVEXT IN ('V', 'D')
           AND EC.CDCLIENTE = :CDCLIENTE
           AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
           AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
    ";

    const GET_BAIRROS = "
        SELECT CDBAIRRO, NMBAIRRO, N
        FROM
            (
             SELECT D.*, ROWNUM as N FROM (
            SELECT CDBAIRRO, NMBAIRRO
                FROM BAIRRO
                WHERE CDPAIS = :CDPAIS
                   AND SGESTADO = :SGESTADO
                   AND CDMUNICIPIO = :CDMUNICIPIO
                   AND UPPER(NMBAIRRO) LIKE UPPER(:NMBAIRRO)
            ) D
             ) data
        WHERE N BETWEEN :FIRST AND :LAST
    ";

    const GET_CITIES = "
        SELECT CDPAIS, SGESTADO, CDMUNICIPIO, NMMUNICIPIO, CDMUNICIBGE, N, POSITION
        FROM
            (
             SELECT D.*, ROWNUM as N FROM (
            SELECT CDPAIS, SGESTADO, CDMUNICIPIO, NMMUNICIPIO, CDMUNICIBGE, DECODE(CDMUNICIPIO, '7107', 1,  '5') AS POSITION
                FROM MUNICIPIO
                WHERE SGESTADO = :SGESTADO
                AND UPPER(NMMUNICIPIO) LIKE UPPER(:NMMUNICIPIO)
            ORDER BY DECODE(CDMUNICIPIO, '7107', 1,  '5'), NMMUNICIPIO
            ) D
             ) data
        WHERE N BETWEEN  :FIRST AND :LAST
        ORDER BY POSITION, NMMUNICIPIO
    ";

    const GET_STATES = "
      SELECT CDPAIS, SGESTADO, NMESTADO
        FROM ESTADO
       WHERE UPPER(NMESTADO) LIKE UPPER(:NMESTADO)
         AND CDPAIS = '0055'
      ORDER BY DECODE(SGESTADO, 'SP', 2), SGESTADO
    ";

    const SAVE_CONSUMER_FIRST_DATA = "
        UPDATE CONSUMIDOR
           SET NMRESPCONS = :NMRESPCONS,
               DSEMAILCONS = :DSEMAILCONS,
               NRTELECONS = :NRTELECONS,
               NRTELE2CONS = :NRTELE2CONS,
               NRCELULARCONS = :NRCELULARCONS,
               DSENDECONS = :DSENDECONS,
               NRENDECONS = :NRENDECONS,
               DSCOMPLENDECONS = :DSCOMPLENDECONS,
               DSREFERENDECONS = :DSREFERENDECONS,
               NRCEPCONS = :NRCEPCONS,
               SGESTADO = :SGESTADO,
               CDMUNICIPIO = :CDMUNICIPIO,
               CDBAIRRO = :CDBAIRRO,
               NMBAIRCONS = :NMBAIRCONS,
               CDPAIS = :CDPAIS,
               VRNOTIFSALDO = NULL,
               NRCPFRESPCON = :NRCPFRESPCON,
               HABENVNOTIF = :HABENVNOTIF,
               HABENVEMAIL = :HABENVEMAIL
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const UPDATE_CONSUMER_DETAILS = "
        UPDATE CONSUMIDOR
           SET NMRESPCONS = :NMRESPCONS,
               DSEMAILCONS = :DSEMAILCONS,
               NRTELECONS = :NRTELECONS,
               NRTELE2CONS = :NRTELE2CONS,
               NRCELULARCONS = :NRCELULARCONS,
               DSENDECONS = :DSENDECONS,
               NRENDECONS = :NRENDECONS,
               DSCOMPLENDECONS = :DSCOMPLENDECONS,
               DSREFERENDECONS = :DSREFERENDECONS,
               NRCEPCONS = :NRCEPCONS,
               SGESTADO = :SGESTADO,
               CDMUNICIPIO = :CDMUNICIPIO,
               CDBAIRRO = :CDBAIRRO,
               NMBAIRCONS = :NMBAIRCONS,
               CDPAIS = :CDPAIS,
               VRNOTIFSALDO = NULL,
               HABENVNOTIF = :HABENVNOTIF,
               HABENVEMAIL = :HABENVEMAIL
         WHERE CDCLIENTE = :CDCLIENTE
           AND NRCPFRESPCON = :NRCPFRESPCON
    ";

    const GET_SONS_NOTIF_VAL = "
        SELECT CDCONSUMIDOR, VRNOTIFSALDO
          FROM CONSUMIDOR
         WHERE CDCLIENTE = :CDCLIENTE
           AND NRCPFRESPCON = :NRCPFRESPCON
    ";

    const UPDATE_SON_NOTIF_VAL = "
        UPDATE CONSUMIDOR
           SET VRNOTIFSALDO = :VRNOTIFSALDO
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    /* ---------- VALUE RESTRICTIONS ----------  */
    const GET_VALUE_RESTRICTIONS = "
        SELECT RA.CDCLIENTE, RA.CDCONSUMIDOR, RA.CDFAMILISALD, FS.NMFAMILISALD,
               NVL(RA.VRCONSDIARAL, 0) AS VRCONSDIARAL, RA.DTULTATURALIM
          FROM RALIMENT RA JOIN FAMILIASALDO FS
                             ON RA.CDFAMILISALD = FS.CDFAMILISALD
         WHERE RA.CDFILIAL = :CDFILIAL
           AND RA.CDCLIENTE = :CDCLIENTE
           AND RA.CDCONSUMIDOR = :CDCONSUMIDOR
           AND RA.VRCONSDIARAL IS NOT NULL
    ";

    const GET_VALUE_RESTRICTION = "
        SELECT RA.CDCLIENTE, RA.CDCONSUMIDOR, RA.CDFAMILISALD, FS.NMFAMILISALD,
               NVL(RA.VRCONSDIARAL, 0) AS VRCONSDIARAL, RA.DTULTATURALIM
          FROM RALIMENT RA JOIN FAMILIASALDO FS
                             ON RA.CDFAMILISALD = FS.CDFAMILISALD
         WHERE RA.CDFILIAL = :CDFILIAL
           AND RA.CDCLIENTE = :CDCLIENTE
           AND RA.CDCONSUMIDOR = :CDCONSUMIDOR
           AND RA.CDFAMILISALD = :CDFAMILISALD
    ";

    const ADD_VALUE_RESTRICTION = "
        INSERT INTO RALIMENT
        (CDFILIAL, CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD,
         IDSALDNEGRAL, VRCONSDIARAL, DTULTATURALIM)
        VALUES
        (:CDFILIAL, :CDCLIENTE, :CDCONSUMIDOR, :CDFAMILISALD,
         'N', :VRCONSDIARAL, SYSDATE)
    ";

    const UPDATE_VALUE_RESTRICTION = "
        UPDATE RALIMENT
           SET VRCONSDIARAL = :VRCONSDIARAL,
               DTULTATURALIM = SYSDATE
          WHERE CDFILIAL = :CDFILIAL
           AND CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
    ";

    const DELETE_VALUE_RESTRICTION = "
        DELETE FROM RALIMENT
         WHERE CDFILIAL = :CDFILIAL
           AND CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
    ";

    const GET_RESTRICTED_PRODUCTS = "
        SELECT CDPRODUTO
          FROM PRODRALIMENT
         WHERE CDFILIAL = :CDFILIAL
           AND CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
    ";

    /* ---------- PRODUCT RESTRICTIONS ----------  */
    const GET_PRODUCT_RESTRICTIONS = "
        SELECT FS.CDFAMILISALD AS ID, NULL AS IDPAI, FS.NMFAMILISALD AS DSRESTRICAO,
               NULL AS QTCONSDIARAL, NULL AS CDPRODUTO, NULL AS QTCONSDIARALFIELD, NULL AS IDBLOQDIARAL
          FROM FAMILIASALDO FS, FAMSALDOFILI FF
         WHERE FF.CDFILIAL = :CDFILIAL
           AND FF.CDFAMILISALD = FS.CDFAMILISALD

        UNION ALL

        SELECT (PR.CDFILIAL||PR.CDCLIENTE||PR.CDCONSUMIDOR||PR.CDFAMILISALD||PR.CDPRODUTO) AS ID,
               CDFAMILISALD AS IDPAI, P.NMPRODUTO AS DSRESTRICAO, QTCONSDIARAL,
               PR.CDPRODUTO, QTCONSDIARAL AS QTCONSDIARALFIELD, PR.IDBLOQDIARAL
          FROM PRODRALIMENT PR, PRODUTO P
         WHERE PR.CDPRODUTO = P.CDPRODUTO
           AND PR.CDFILIAL = :CDFILIAL
           AND PR.CDCLIENTE = :CDCLIENTE
           AND PR.CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const GET_CONSUMER_FAMILIES = "
        SELECT FS.CDFAMILISALD, FS.NMFAMILISALD
          FROM FAMSALDOFILI FF JOIN FAMILIASALDO FS
                                 ON FS.CDFAMILISALD = FF.CDFAMILISALD
         WHERE FF.CDFILIAL = :CDFILIAL
    ";

    // OLD QUERY, DOES NOT USE GROUPS

    const GET_FAMILY_PRODUCTS = "
      SELECT DISTINCT P.CDPRODUTO, P.NMPRODUTO
          FROM FAMSALDOPROD F JOIN PRODUTO P
                              ON F.CDPRODUTO = P.CDPRODUTO
                              JOIN ITMENUCONFTE I
                              ON F.CDFILIAL = I.CDFILIAL
                              AND F.CDPRODUTO = I.CDIDENTBUTON
	WHERE F.CDFILIAL = :CDFILIAL
        AND F.CDFAMILISALD = :CDFAMILISALD
        AND I.IDTPBUTTON = '1'
        AND I.IDTPBUTONAUX = '2'
        AND P.IDPRODATIVPR = 'S'
        AND F.CDPRODUTO NOT IN (SELECT CDPRODUTO
																                                                                           FROM PRODRALIMENT
          WHERE CDFILIAL = :CDFILIAL
          AND CDFAMILISALD = :CDFAMILISALD
          AND CDCLIENTE = :CDCLIENTE
          AND CDCONSUMIDOR = :CDCONSUMIDOR)
          ORDER BY P.NMPRODUTO
    ";

    /*const GET_FAMILY_PRODUCTS = "
        SELECT DISTINCT PR.CDIDENTBUTON AS CDPRODUTO, PR.DSBUTTON AS NMPRODUTO, GR.DSBUTTON AS NMGRUPO, PR.DSBUTTON AS PRIMARY, GR.DSBUTTON AS PARENT
            
        FROM ITMENUCONFTE PR
      
        JOIN FAMSALDOPROD F
          ON F.CDFILIAL = PR.CDFILIAL
        AND F.CDPRODUTO = PR.CDIDENTBUTON

        JOIN PRODUTO PD
          ON PR.CDIDENTBUTON = PD.CDPRODUTO
    
        JOIN (SELECT IT.CDFILIAL, IT.NRCONFTELA, IT.IDTPBUTTON, IT.NRBUTTON,
              IT.NRPGCONFTELA, IT.DSBUTTON, IT.NRPGCONFTELA||IT.NRBUTTON AS CDGRUPO, 
              IT.DSENDEIMG AS IMGGRUPO
                
               FROM ITMENUCONFTE IT
      
              WHERE IT.NRCONFTELA = (SELECT APPMENUCONFTE AS NRCONFTELA
                                       FROM PARAVEND
                                      WHERE CDFILIAL = :CDFILIAL)
                AND IT.CDFILIAL = :CDFILIAL
                AND IDTPBUTTON = '2') GR
          ON PR.CDFILIAL     = GR.CDFILIAL
        AND PR.NRCONFTELA   = GR.NRCONFTELA
        AND PR.IDTPBUTONAUX = GR.IDTPBUTTON
        AND PR.NRBUTTONAUX  = GR.NRBUTTON
        AND PR.NRPGCONFTAUX = GR.NRPGCONFTELA

    LEFT JOIN (SELECT CDPRODUTO, CDLOJA, CDFILIAL
                FROM PRODBLOQVND
              WHERE PRODBLOQVND.CDFILIAL = :CDFILIAL) PB
          ON PB.CDPRODUTO = PD.CDPRODUTO
        AND PB.CDFILIAL  = PR.CDFILIAL
      
      WHERE PB.CDPRODUTO IS NULL 
        AND F.CDFAMILISALD = :CDFAMILISALD
        AND F.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                  FROM PRODRALIMENT
                                  WHERE CDFILIAL = :CDFILIAL
                                    AND CDFAMILISALD = :CDFAMILISALD
                                    AND CDCLIENTE = :CDCLIENTE
                                    AND CDCONSUMIDOR = :CDCONSUMIDOR)
    ";*/

    const ADD_PRODUCT_RESTRICTION = "
        INSERT INTO PRODRALIMENT
        (CDFILIAL, CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD,
         CDPRODUTO, QTCONSDIARAL, IDBLOQDIARAL)
        VALUES
        (:CDFILIAL, :CDCLIENTE, :CDCONSUMIDOR, :CDFAMILISALD,
         :CDPRODUTO, :QTCONSDIARAL, :IDBLOQDIARAL)
    ";

    const UPDATE_PRODUCT_RESTRICTION = "
        UPDATE PRODRALIMENT
           SET QTCONSDIARAL = :QTCONSDIARAL,
               IDBLOQDIARAL = :IDBLOQDIARAL
         WHERE CDFILIAL = :CDFILIAL
           AND CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
           AND CDPRODUTO = :CDPRODUTO
    ";

    const DELETE_PRODUCT_RESTRICTION = "
        DELETE
          FROM PRODRALIMENT
         WHERE CDFILIAL = :CDFILIAL
           AND CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
           AND CDPRODUTO = :CDPRODUTO
    ";

    /* ---------- ---------- */

    const GET_NRSEQMOVEXT = "
        SELECT LPAD(NVL(MAX(NRSEQMOVEXT)+1,1),3,'0') AS NRSEQMOVEXT
          FROM EXTRATOCONS
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const INSERT_EXTRATOCONS = "
        INSERT INTO EXTRATOCONS
        (CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, DTMOVEXTCONS,
         DSOPEEXTCONS, VRMOVEXTCONS, IDTPMOVEXT, NRSEQMOVEXT,
         DTULTATUEXT, VRSALDCONEXT, NRORG, IDATIVO, IDIMPEXTRATO,
         CDTIPORECE, CDFILIAL)
        VALUES
        (:CDCLIENTE, :CDCONSUMIDOR, :CDFAMILISALD, SYSDATE,
         :DSOPEEXTCONS, :VRMOVEXTCONS, :IDTPMOVEXT, :NRSEQMOVEXT,
         SYSDATE, :VRSALDCONEXT, 1, 'S', 'S',
         :CDTIPORECE, :CDFILIAL)
    ";

    const CHECK_SALDOCONS = "
      SELECT * FROM SALDOCONS
       WHERE CDCONSUMIDOR = :CDCONSUMIDOR
         AND CDCLIENTE = :CDCLIENTE
         AND CDFAMILISALD = :CDFAMILISALD
    ";

    const INSERT_SALDOCONS = "
      INSERT INTO SALDOCONS
      (CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRSALDCONFAM, NRORG, IDATIVO)
      VALUES
      (:CDCLIENTE, :CDCONSUMIDOR, :CDFAMILISALD, :VRSALDCONFAM, 1, 'S')
    ";

    const UPDATE_BALANCE = "
      UPDATE SALDOCONS
         SET VRSALDCONFAM = :VRSALDCONFAM
      WHERE CDCLIENTE = :CDCLIENTE
        AND CDCONSUMIDOR = :CDCONSUMIDOR
        AND CDFAMILISALD = :CDFAMILISALD
    ";

    const GET_EXTRATOCONS_VRSALDCONEXT = "
      SELECT VRSALDCONEXT, CDCLIENTE, CDCONSUMIDOR
        FROM EXTRATOCONS
       WHERE CDCLIENTE = :CDCLIENTE
         AND CDCONSUMIDOR = :CDCONSUMIDOR
         AND CDFAMILISALD = :CDFAMILISALD
       ORDER BY DTMOVEXTCONS DESC
    ";

    const GET_DTMOVEXTCONS = "
        SELECT MIN(DTMOVEXTCONS) AS DTMOVEXTCONS
          FROM EXTRATOCONS
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const GET_PASSWORD = "
        SELECT CDSENHACONSMD5
             FROM CONSUMIDOR
            WHERE CDCLIENTE = :CDCLIENTE
           AND NMLOGINCONS = :NMLOGINCONS
    ";

    const SQL_CHANGE_PASSWORD = "
        UPDATE CONSUMIDOR
           SET CDSENHACONSMD5 = :CDSENHACONSMD5
         WHERE CDCLIENTE = :CDCLIENTE
           AND NMLOGINCONS = :NMLOGINCONS
    ";

    const SET_PASSWORD = "
        UPDATE CONSUMIDOR
           SET CDSENHACONSMD5 = :P_CDSENHACONSMD5
         WHERE CDCLIENTE = :P_CDCLIENTE
           AND NMLOGINCONS = :P_NMLOGINCONS
    ";

    // ------------------------- BANCO -----------------------------
    const GET_BANCO_ESPECIFICO = "
        SELECT B.CDBANCO, B.DSINSCEMPVND, B.QTDIASVENVND, B.CDAGENCIAVND, B.CDCONTCORVND,
               C.CDCONTCORR, CDBANCOCONVVND ,CDCONTRATOVND, B.NMBANCO
           FROM BANCO B, CONTCORR C
          WHERE C.CDREDUCONT = B.CDCONTCORVND
      ";

      const GET_BANCOS = "
        SELECT B.CDBANCO, B.DSINSCEMPVND, B.QTDIASVENVND, B.CDAGENCIAVND,
               B.CDCONTCORVND, C.CDCONTCORR, B.NMBANCO, CDPICTCONT,
               CDPICTAGEN, CDBANCOCONVVND, CDCONTRATOVND, B.CDBANCCNAB
           FROM BANCO B, CONTCORR C
          WHERE C.CDREDUCONT = B.CDCONTCORVND
      ";

    const GET_ESITEF_DETAILS = "
        SELECT IDLOJAESITEF, CDLOJAESITEF
        FROM PARAMGERAL
      ";

    const GET_ESITEFFLAGS = "
      SELECT NMBANDEIRA, IDESITEF, CDTIPORECE
      FROM BANDEIRAESITEF
      ORDER BY NRSEQBANDEIRA
  ";
      //-----------------------------------------Forgot my password (VICTOR)-------------
      const GET_HASH_BY_CONSUMIDOR = "
        SELECT DSHASHALTERASENHA FROM CONSUMIDOR
         WHERE CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDCLIENTE = :CDCLIENTE
    ";

    const UPDATE_PASSWORD = "
        UPDATE CONSUMIDOR
           SET CDSENHACONSMD5 = :CDSENHACONSMD5
         WHERE CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDCLIENTE = :CDCLIENTE
    ";

    const UPDATE_HASH_ALTERASENHA = "
        UPDATE CONSUMIDOR
           SET DSHASHALTERASENHA = :DSHASHALTERASENHA
         WHERE CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDCLIENTE = :CDCLIENTE
    ";

    const GET_CONSUMER_PASSWORDS = "
        SELECT CDCLIENTE, CDCONSUMIDOR, CDSENHACONSUMIDORWEB
          FROM CONSUMIDOR
         WHERE CDSENHACONSUMIDORWEB IS NOT NULL
           AND CDSENHACONSMD5 IS NULL
    ";

    const SET_CONSUMER_PASSWORDS = "
        UPDATE CONSUMIDOR
           SET CDSENHACONSMD5 = :CDSENHACONSMD5
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const GET_TIPOCONSFILI_RESALIM = "
        SELECT SUBSTR(DSACESSOSITE, -15, 1) AS DSACESSOSITE
          FROM TIPOCONSFILI
         WHERE CDFILIAL   = :CDFILIAL
           AND CDTIPOCONS = :CDTIPOCONS
    ";

    //------------------------------------------------ Nutritional vision -------------

    const GET_PRODUCT_GROUPS_NUTRI = "
        SELECT NMGRUPPROD, CDGRUPPROD, SUM(QUANTIDADE) AS QTPRODVEND
          FROM (
                SELECT PR.CDPRODUTO, PR.NMPRODUTO,
                       NVL(GP.NMGRUPPROD, 'OUTROS') AS NMGRUPPROD, GP.CDGRUPPROD,
                       NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMSUBGRPROD, SP.CDSUBGRPROD,
                       TO_CHAR(EC.DTMOVEXTCONS, 'dd/mm/yy') AS DTMOVEXTCONS, TRUNC(EC.DTMOVEXTCONS) AS DATA,
                       ((IV.QTPRODVEND * (IV.VRUNITVEND - IV.VRDESITVEND + IV.VRACRITVEND))) AS MOVIMENTACAO,
                       EC.IDTPMOVEXT, IV.QTPRODVEND AS QUANTIDADE
                  FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                       PRODUTO PR LEFT JOIN NVSUBGRPROD SG ON SG.CDPRODUTO = PR.CDPRODUTO
                                  LEFT JOIN SUBGRUPPROD SP ON SP.CDSUBGRPROD = SG.CDSUBGRPROD
                                                          AND SP.CDGRUPPROD = SG.CDGRUPPROD
                                  LEFT JOIN GRUPPROD GP ON GP.CDGRUPPROD = SG.CDGRUPPROD
                 WHERE EC.CDCLIENTE = :CDCLIENTE
                   AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                   AND EC.IDTPMOVEXT = 'V'
                   AND EC.CDFAMILISALD = FS.CDFAMILISALD
                   AND EC.CDFILIAL = IV.CDFILIAL
                   AND EC.CDCAIXA = IV.CDCAIXA
                   AND EC.NRSEQVENDA = IV.NRSEQVENDA
                   AND IV.CDPRODUTO = PR.CDPRODUTO
                   AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
               )
         GROUP BY NMGRUPPROD, CDGRUPPROD
    ";

    const GET_PRODUCT_SUBGROUPS_NUTRI = "
        SELECT NMSUBGRPROD, CDGRUPPROD, CDSUBGRPROD, SUM(QUANTIDADE) AS QTPRODVEND
          FROM (
                SELECT PR.CDPRODUTO, PR.NMPRODUTO,
                       NVL(GP.NMGRUPPROD, 'OUTROS') AS NMGRUPPROD, GP.CDGRUPPROD,
                       NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMSUBGRPROD, SP.CDSUBGRPROD,
                       TO_CHAR(EC.DTMOVEXTCONS, 'dd/mm/yy') AS DTMOVEXTCONS, TRUNC(EC.DTMOVEXTCONS) AS DATA,
                       ((IV.QTPRODVEND * (IV.VRUNITVEND - IV.VRDESITVEND + IV.VRACRITVEND))) AS MOVIMENTACAO,
                       EC.IDTPMOVEXT, IV.QTPRODVEND AS QUANTIDADE
                  FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                       PRODUTO PR LEFT JOIN NVSUBGRPROD SG ON SG.CDPRODUTO = PR.CDPRODUTO
                                  LEFT JOIN SUBGRUPPROD SP ON SP.CDSUBGRPROD = SG.CDSUBGRPROD
                                                          AND SP.CDGRUPPROD = SG.CDGRUPPROD
                                  LEFT JOIN GRUPPROD GP ON GP.CDGRUPPROD = SG.CDGRUPPROD
                 WHERE EC.CDCLIENTE = :CDCLIENTE
                   AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                   AND EC.IDTPMOVEXT = 'V'
                   AND EC.CDFAMILISALD = FS.CDFAMILISALD
                   AND EC.CDFILIAL = IV.CDFILIAL
                   AND EC.CDCAIXA = IV.CDCAIXA
                   AND EC.NRSEQVENDA = IV.NRSEQVENDA
                   AND IV.CDPRODUTO = PR.CDPRODUTO
                   AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
               )
         WHERE NVL(CDGRUPPROD, 'NULL') = :CDGRUPPROD
         GROUP BY NMSUBGRPROD, CDGRUPPROD, CDSUBGRPROD
    ";

    const GET_PRODUCTS_NUTRI = "
        SELECT NMPRODUTO, CDPRODUTO, CDGRUPPROD, CDSUBGRPROD, SUM(QUANTIDADE) AS QTPRODVEND
          FROM (
                SELECT PR.CDPRODUTO, PR.NMPRODUTO,
                       NVL(GP.NMGRUPPROD, 'OUTROS') AS NMGRUPPROD, GP.CDGRUPPROD,
                       NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMSUBGRPROD, SP.CDSUBGRPROD,
                       TO_CHAR(EC.DTMOVEXTCONS, 'dd/mm/yy') AS DTMOVEXTCONS, TRUNC(EC.DTMOVEXTCONS) AS DATA,
                       ((IV.QTPRODVEND * (IV.VRUNITVEND - IV.VRDESITVEND + IV.VRACRITVEND))) AS MOVIMENTACAO,
                       EC.IDTPMOVEXT, IV.QTPRODVEND AS QUANTIDADE
                  FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                       PRODUTO PR LEFT JOIN NVSUBGRPROD SG ON SG.CDPRODUTO = PR.CDPRODUTO
                                  LEFT JOIN SUBGRUPPROD SP ON SP.CDSUBGRPROD = SG.CDSUBGRPROD
                                                          AND SP.CDGRUPPROD = SG.CDGRUPPROD
                                  LEFT JOIN GRUPPROD GP ON GP.CDGRUPPROD = SG.CDGRUPPROD
                 WHERE EC.CDCLIENTE = :CDCLIENTE
                   AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                   AND EC.IDTPMOVEXT = 'V'
                   AND EC.CDFAMILISALD = FS.CDFAMILISALD
                   AND EC.CDFILIAL = IV.CDFILIAL
                   AND EC.CDCAIXA = IV.CDCAIXA
                   AND EC.NRSEQVENDA = IV.NRSEQVENDA
                   AND IV.CDPRODUTO = PR.CDPRODUTO
                   AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
               )
         WHERE NVL(CDGRUPPROD, 'NULL') = :CDGRUPPROD
           AND NVL(CDSUBGRPROD, 'NULL') = :CDSUBGRPROD
         GROUP BY NMPRODUTO, CDPRODUTO, CDGRUPPROD, CDSUBGRPROD
    ";

    const GET_GROUPED_PRODUCTS_BY_DAY = "
          SELECT DTMOVEXTCONS, LISTAGG(NMPRODUTO,';')WITHIN GROUP (ORDER BY NMPRODUTO) AS PRODUTOS, DTMOVEXTDIAMES
                FROM (
                       SELECT PR.CDPRODUTO, PR.NMPRODUTO, TO_CHAR(EC.DTMOVEXTCONS, 'dd/mm/yy') AS DTMOVEXTDIAMES,
                              TRUNC(EC.DTMOVEXTCONS) AS DTMOVEXTCONS
                         FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                              PRODUTO PR
                        WHERE EC.CDCLIENTE = :CDCLIENTE
                          AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                          AND EC.IDTPMOVEXT = 'V'
                          AND EC.CDFAMILISALD = FS.CDFAMILISALD
                          AND EC.CDFILIAL = IV.CDFILIAL
                          AND EC.CDCAIXA = IV.CDCAIXA
                          AND EC.NRSEQVENDA = IV.NRSEQVENDA
                          AND IV.CDPRODUTO = PR.CDPRODUTO
                          AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
                          ORDER BY EC.DTMOVEXTCONS ASC
                   )
          GROUP BY DTMOVEXTCONS, DTMOVEXTDIAMES
    ";

    const GET_PRODUCTS_BY_DAY = "
        SELECT PR.CDPRODUTO, SUBSTR(PR.NMPRODUTO,1,22) NMPRODUTO, TO_CHAR(EC.DTMOVEXTCONS, 'dd/mm/yy') AS DTMOVEXTDIAMES,
               TO_CHAR(EC.DTMOVEXTCONS,'dd/mm/yyyy') AS DTMOVEXTCONS
          FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
               PRODUTO PR
         WHERE EC.CDCLIENTE = :CDCLIENTE
           AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
           AND EC.IDTPMOVEXT = 'V'
           AND EC.CDFAMILISALD = FS.CDFAMILISALD
           AND EC.CDFILIAL = IV.CDFILIAL
           AND EC.CDCAIXA = IV.CDCAIXA
           AND EC.NRSEQVENDA = IV.NRSEQVENDA
           AND IV.CDPRODUTO = PR.CDPRODUTO
           AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
      ORDER BY EC.DTMOVEXTCONS ASC
    ";


    const _GET_PRODUCTS_NUTRI_INFORMATIONS = "
        SELECT  NVL(IF.VRNUTRCHO,0) AS VRNUTRCHO,NVL(IF.VRNUTRLIP,0) AS VRNUTRLIP,NVL(IF.VRNUTRPTN,0) AS VRNUTRPTN,NVL(IF.VRNUTRKCAL,0) AS VRNUTRKCAL, PR.NMPRODUTO
          FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
               PRODUTO PR, INFNUTRPROD IF
         WHERE EC.CDCLIENTE = :CDCLIENTE
           AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
           AND EC.IDTPMOVEXT = 'V'
           AND EC.CDFAMILISALD = FS.CDFAMILISALD
           AND EC.CDFILIAL = IV.CDFILIAL
           AND EC.CDCAIXA = IV.CDCAIXA
           AND EC.NRSEQVENDA = IV.NRSEQVENDA
           AND IV.CDPRODUTO = PR.CDPRODUTO
           AND PR.CDPRODUTO = IF.CDPRODUTO(+)
           AND (TRUNC(EC.DTMOVEXTCONS) = TRUNC(TO_DATE(:DTMOVEXTCONS,'dd/mm/yyyy')))
      ORDER BY EC.DTMOVEXTCONS ASC
    ";

    const _GET_PRODUCTS_NUTRI_INFORMATIONS_TOTAL = "
        SELECT 'TOTAL' as NMPRODUTO, SUM(N.VRNUTRKCAL) AS VRNUTRKCAL, SUM(N.VRNUTRPTN) AS VRNUTRPTN, SUM(N.VRNUTRLIP) AS VRNUTRLIP, SUM(N.VRNUTRCHO) as VRNUTRCHO
              FROM(  SELECT NVL(IF.VRNUTRCHO,0) AS VRNUTRCHO,NVL(IF.VRNUTRLIP,0) AS VRNUTRLIP,NVL(IF.VRNUTRPTN,0) AS VRNUTRPTN,NVL(IF.VRNUTRKCAL,0) AS VRNUTRKCAL
                      FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                           PRODUTO PR, INFNUTRPROD IF
                     WHERE EC.CDCLIENTE = :CDCLIENTE
                       AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                       AND EC.IDTPMOVEXT = 'V'
                       AND EC.CDFAMILISALD = FS.CDFAMILISALD
                       AND EC.CDFILIAL = IV.CDFILIAL
                       AND EC.CDCAIXA = IV.CDCAIXA
                       AND EC.NRSEQVENDA = IV.NRSEQVENDA
                       AND IV.CDPRODUTO = PR.CDPRODUTO
                       AND PR.CDPRODUTO = IF.CDPRODUTO(+)
                       AND (TRUNC(EC.DTMOVEXTCONS) = TRUNC(TO_DATE(:DTMOVEXTCONS,'dd/mm/yyyy')))
              ) N
    ";

    const _GET_MEDIA_CONSUMO = "
          SELECT SUM(MOVIMENTACAO)/NVL(COUNT(*),1) AS MEDIACONSUMO
            FROM (
                SELECT DTMOV, NVL(SUM(MOVIMENTACAO),0) AS MOVIMENTACAO
                  FROM (
                       SELECT TRUNC(EC.DTMOVEXTCONS) AS DTMOV,
                              ((IV.QTPRODVEND * (IV.VRUNITVEND - IV.VRDESITVEND + IV.VRACRITVEND))) AS MOVIMENTACAO
                         FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                              PRODUTO PR LEFT JOIN NVSUBGRPROD SG ON SG.CDPRODUTO = PR.CDPRODUTO
                                  LEFT JOIN SUBGRUPPROD SP ON SP.CDSUBGRPROD = SG.CDSUBGRPROD
                                                          AND SP.CDGRUPPROD = SG.CDGRUPPROD
                                  LEFT JOIN GRUPPROD GP ON GP.CDGRUPPROD = SG.CDGRUPPROD
                        WHERE EC.CDCLIENTE = :CDCLIENTE
                          AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                          AND EC.IDTPMOVEXT = 'V'
                          AND EC.CDFAMILISALD = FS.CDFAMILISALD
                          AND EC.CDFILIAL = IV.CDFILIAL
                          AND EC.CDCAIXA = IV.CDCAIXA
                          AND EC.NRSEQVENDA = IV.NRSEQVENDA
                          AND IV.CDPRODUTO = PR.CDPRODUTO
                          AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
                  ) DIAS
                GROUP BY DTMOV
            )
        ";

    // ---- Informações nutricionais

    const GET_GROUPPED_ROTFABRICA_PRODUTO = "
        SELECT PR.NMPRODUTO,PR.CDPRODUTO, DECODE(LISTAGG(RF.CDSUBPRODUTO||'#'||RF.QTSUBPRODROT,'|')WITHIN GROUP (ORDER BY PR.CDPRODUTO),'#','NC',LISTAGG(RF.CDSUBPRODUTO||'#'||RF.QTSUBPRODROT,'|')WITHIN GROUP (ORDER BY PR.CDPRODUTO)) SUBPRODUTOS
          FROM PRODUTO PR, ROTFABRICA RF
         WHERE PR.CDPRODUTO = RF.CDPRODUTO(+)
           AND PR.CDPRODUTO = :CDPRODUTO
      GROUP BY PR.NMPRODUTO, PR.CDPRODUTO
    ";

    const GET_PRODUCT_NUTRIENTS = "
         SELECT N.CDNUTRIENTE, N.NMNUTRIENTE, LOWER(N.SGUNIDADE) as SGUNIDADE,
          (CASE
               WHEN NP.QTNUTRPROD * :FATORCOMPOSICAO < 1 THEN TO_CHAR(NP.QTNUTRPROD * :FATORCOMPOSICAO ,'0.99')
               ELSE TO_CHAR(NP.QTNUTRPROD * :FATORCOMPOSICAO)
           END) VRNUTRIENTE
          FROM NUTRIENTE N, NUTRPROD NP
         WHERE NP.CDPRODUTO = :CDPRODUTO
           AND N.CDNUTRIENTE = NP.CDNUTRIENTE
    ";

    const GET_PRODUCT = "
        SELECT VRPESOUNID, SGUNIDADE
          FROM PRODUTO
         WHERE CDPRODUTO = :CDPRODUTO
    ";

    const GET_PRODUCTS_NUTRI_INFORMATIONS = "
        SELECT  NVL(IF.VRNUTRCHO,0) AS VRNUTRCHO,NVL(IF.VRNUTRLIP,0) AS VRNUTRLIP,NVL(IF.VRNUTRPTN,0) AS VRNUTRPTN,NVL(IF.VRNUTRKCAL,0) AS VRNUTRKCAL, PR.NMPRODUTO
          FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
               PRODUTO PR, INFNUTRPROD IF
         WHERE EC.CDCLIENTE = :CDCLIENTE
           AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
           AND EC.IDTPMOVEXT = 'V'
           AND EC.CDFAMILISALD = FS.CDFAMILISALD
           AND EC.CDFILIAL = IV.CDFILIAL
           AND EC.CDCAIXA = IV.CDCAIXA
           AND EC.NRSEQVENDA = IV.NRSEQVENDA
           AND IV.CDPRODUTO = PR.CDPRODUTO
           AND PR.CDPRODUTO = IF.CDPRODUTO(+)
           AND (TRUNC(EC.DTMOVEXTCONS) = TRUNC(TO_DATE(:DTMOVEXTCONS,'dd/mm/yyyy')))
      ORDER BY EC.DTMOVEXTCONS ASC
    ";

    const GET_PRODUCTS_NUTRI_INFORMATIONS_TOTAL = "
        SELECT 'TOTAL' as NMPRODUTO, SUM(N.VRNUTRKCAL) AS VRNUTRKCAL, SUM(N.VRNUTRPTN) AS VRNUTRPTN, SUM(N.VRNUTRLIP) AS VRNUTRLIP, SUM(N.VRNUTRCHO) as VRNUTRCHO
              FROM(  SELECT NVL(IF.VRNUTRCHO,0) AS VRNUTRCHO,NVL(IF.VRNUTRLIP,0) AS VRNUTRLIP,NVL(IF.VRNUTRPTN,0) AS VRNUTRPTN,NVL(IF.VRNUTRKCAL,0) AS VRNUTRKCAL
                      FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                           PRODUTO PR, INFNUTRPROD IF
                     WHERE EC.CDCLIENTE = :CDCLIENTE
                       AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                       AND EC.IDTPMOVEXT = 'V'
                       AND EC.CDFAMILISALD = FS.CDFAMILISALD
                       AND EC.CDFILIAL = IV.CDFILIAL
                       AND EC.CDCAIXA = IV.CDCAIXA
                       AND EC.NRSEQVENDA = IV.NRSEQVENDA
                       AND IV.CDPRODUTO = PR.CDPRODUTO
                       AND PR.CDPRODUTO = IF.CDPRODUTO(+)
                       AND (TRUNC(EC.DTMOVEXTCONS) = TRUNC(TO_DATE(:DTMOVEXTCONS,'dd/mm/yyyy')))
              ) N
    ";

    const GET_NUTRI_RECOMENDATION_BY_FILIAL = "

        SELECT P.DSRECOMENDNUTRI
          FROM PARAVEND P
         WHERE P.CDFILIAL = :CDFILIAL
    ";

    const GET_MEDIA_CONSUMO = "
          SELECT SUM(MOVIMENTACAO)/NVL(COUNT(*),1) AS MEDIACONSUMO
            FROM (
                SELECT DTMOV, NVL(SUM(MOVIMENTACAO),0) AS MOVIMENTACAO
                  FROM (
                       SELECT TRUNC(EC.DTMOVEXTCONS) AS DTMOV,
                              ((IV.QTPRODVEND * (IV.VRUNITVEND - IV.VRDESITVEND + IV.VRACRITVEND))) AS MOVIMENTACAO
                         FROM EXTRATOCONS EC, ITEMVENDA IV, FAMILIASALDO FS,
                              PRODUTO PR LEFT JOIN NVSUBGRPROD SG ON SG.CDPRODUTO = PR.CDPRODUTO
                                  LEFT JOIN SUBGRUPPROD SP ON SP.CDSUBGRPROD = SG.CDSUBGRPROD
                                                          AND SP.CDGRUPPROD = SG.CDGRUPPROD
                                  LEFT JOIN GRUPPROD GP ON GP.CDGRUPPROD = SG.CDGRUPPROD
                        WHERE EC.CDCLIENTE = :CDCLIENTE
                          AND EC.CDCONSUMIDOR = :CDCONSUMIDOR
                          AND EC.IDTPMOVEXT = 'V'
                          AND EC.CDFAMILISALD = FS.CDFAMILISALD
                          AND EC.CDFILIAL = IV.CDFILIAL
                          AND EC.CDCAIXA = IV.CDCAIXA
                          AND EC.NRSEQVENDA = IV.NRSEQVENDA
                          AND IV.CDPRODUTO = PR.CDPRODUTO
                          AND (TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy'))
                  ) DIAS
                GROUP BY DTMOV
            )
        ";

    // ---- Informações nutricionais

    const GET_ROTFABRICA_PRODUTO = "
        SELECT PR.NMPRODUTO, PR.CDPRODUTO, RF.QTSUBPRODROT, RF.CDSUBPRODUTO,
               DECODE(LISTAGG(RF.CDSUBPRODUTO||'#'||RF.QTSUBPRODROT,'|')WITHIN GROUP (ORDER BY PR.CDPRODUTO),'#','NC',LISTAGG(RF.CDSUBPRODUTO||'#'||RF.QTSUBPRODROT,'|')WITHIN GROUP (ORDER BY PR.CDPRODUTO)) AS SUBPRODUTOS
          FROM PRODUTO PR, ROTFABRICA RF
         WHERE PR.CDPRODUTO = RF.CDPRODUTO(+)
           AND PR.CDPRODUTO = :CDPRODUTO
        GROUP BY PR.NMPRODUTO, PR.CDPRODUTO, RF.QTSUBPRODROT, RF.CDSUBPRODUTO
    ";

    const GET_NUTRIENTES_PRODUTO = "
      SELECT P.CDPRODUTO, P.NMPRODUTO, N.NMNUTRIENTE, (NP.QTNUTRPROD * :CONVERSAO) QUANTIDADE
        FROM PRODUTO P, NUTRIENTE N, NUTRPROD NP
       WHERE  P.CDPRODUTO = :CDPRODUTO
              P.CDPRODUTO = NP.CDPRODUTO
              N.CDNUTRIENTE = NP.CDNUTRIENTE
    ";

    const IS_FIRST_INSERTION = "
      SELECT *
        FROM EXTRATOCONS
       WHERE CDCLIENTE = :CDCLIENTE
         AND CDCONSUMIDOR = :CDCONSUMIDOR
         AND CDFAMILISALD = :CDFAMILISALD
    ";

    const LOW_GROUPED_BALANCES = "
        SELECT C.CDCLIENTE, C.CDCONSUMIDOR, C.NMCONSUMIDOR, C.NMRESPCONS, C.NRCPFRESPCON, C.DSEMAILCONS, B.GBALANCE
          FROM CONSUMIDOR C JOIN (SELECT CDCLIENTE, CDCONSUMIDOR, SUM(VRSALDCONFAM) AS GBALANCE
                                    FROM SALDOCONS
                                   GROUP BY CDCLIENTE, CDCONSUMIDOR) B
                              ON B.CDCLIENTE = C.CDCLIENTE
                             AND B.CDCONSUMIDOR = C.CDCONSUMIDOR
         WHERE C.VRNOTIFSALDO IS NOT NULL
           AND B.GBALANCE < C.VRNOTIFSALDO
           AND C.NRCPFRESPCON IS NOT NULL
           AND C.DSEMAILCONS IS NOT NULL
           AND C.IDSITCONSUMI = '1'
           AND C.HABENVEMAIL = 'S'
    ";

    const GET_ESITEF_DETAILS_FILI_GER = "
        SELECT NVL(PV.IDLOJAESITEFFIL,PG.IDLOJAESITEF) IDLOJAESITEF, NVL(PV.CDLOJAESITEFFIL,PG.CDLOJAESITEF) CDLOJAESITEF, NVL(PV.IDPLATAFORMAPAG,PG.IDPLATAFORMAPAG) IDPLATAFORMAPAG
          FROM PARAVEND PV, PARAMGERAL PG
         WHERE PV.CDFILIAL = :CDFILIAL
    ";

    const CHECK_CONSUMER_DETAILS = "
        SELECT CDCLIENTE, CDCONSUMIDOR, NMCONSUMIDOR, NMRESPCONS, DSEMAILCONS
          FROM CONSUMIDOR
         WHERE CDCLIENTE = :CDCLIENTE
           AND NRCPFRESPCON = :NRCPFRESPCON
    ";

    const ACCEPT_CONTRACT = "
        UPDATE CONSUMIDOR
           SET IDCONTRATO = 'S'
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    /*const GET_FILIAL_BY_CLIENT = "
        SELECT DSEMAILCLUSO, CDFILIAL
          FROM PARAVEND
         WHERE CDFILIAL = (SELECT CDFILIAL FROM CLIENFILIAL CF
                            WHERE CF.CDCLIENTE = :CDCLIENTE
                              AND CF.IDPERMVENDAFOS = 'S'
                              AND CF.IDCLIUTSITE = 'S')
    ";*/
    
    const GET_FILIAL_BY_CLIENT = "
        SELECT DSEMAILCLUSO
          FROM PARAMGERAL
    ";

    // AUTORECHARGE

    const CHECK_DUPLICATED_CREDIT_CARD_TOKEN ="
        SELECT DSTOKEN
          FROM CARTCREDCONS
         WHERE DSTOKEN = :DSTOKEN
           AND CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const GET_NRSEQBANDEIRA = "
        SELECT NRSEQBANDEIRA
          FROM BANDEIRAESITEF
         WHERE IDESITEF = :IDESITEF
    ";

    const STORE_CREDIT_CARD_TOKEN = "
        INSERT INTO CARTCREDCONS(
            CDCARTCRED, NRSEQBANDEIRA, CDCLIENTE, CDCONSUMIDOR, NRULTNUM, DSTOKEN, IDTPCARTCRED, NMTITULAR, DTEXPIRACAO, CARTCREDMD5
        )
        VALUES(
            :CDCARTCRED, :NRSEQBANDEIRA, :CDCLIENTE, :CDCONSUMIDOR, :NRULTNUM, :DSTOKEN, 'O', :NMTITULAR, :DTEXPIRACAO, :CARTCREDMD5
        )
    ";

    const GET_CREDIT_CARD = "
        SELECT C.IDTPCARTCRED, C.DSTOKEN, B.NMBANDEIRA, B.IDESITEF,
               B.NRSEQBANDEIRA, C.NRULTNUM, C.CDCARTCRED, C.NMTITULAR,
               C.DTEXPIRACAO, C.CDCLIENTE, C.CDCONSUMIDOR, T.CDTIPORECE, T.IDTIPORECE
          FROM CARTCREDCONS C
          JOIN BANDEIRAESITEF B ON C.NRSEQBANDEIRA = B.NRSEQBANDEIRA
          JOIN TIPORECE T ON B.CDTIPORECE = T.CDTIPORECE
         WHERE C.CDCLIENTE = :CDCLIENTE
         AND C.CDCONSUMIDOR IN (SELECT CDCONSUMIDOR
                                FROM CONSUMIDOR
                                WHERE NRCPFRESPCON = (SELECT NRCPFRESPCON
                                                      FROM CONSUMIDOR
                                                      WHERE CDCLIENTE = :CDCLIENTE
                                                      AND CDCONSUMIDOR = :CDCONSUMIDOR)
                                 AND CDCLIENTE = :CDCLIENTE)
    ";

    const GET_FILIAL_KEYS = "
        SELECT IDLOJAESITEFFIL, CDLOJAESITEFFIL
          FROM PARAVEND
         WHERE CDFILIAL = :CDFILIAL
    ";

    const GET_AVALIABLE_FLAGS = "
        SELECT BS.IDESITEF, BS.NMBANDEIRA
          FROM TIPORECE TR
          JOIN BANDESITEFFIL BS ON BS.CDTIPORECE = TR.CDTIPORECE
         WHERE (TR.IDTIPORECE = '1' OR TR.CDTIPORECE = '025')
           AND BS.CDFILIAL = :CDFILIAL

         UNION

        SELECT BF.IDESITEF, BF.NMBANDEIRA
          FROM TIPORECE TR
          JOIN BANDEIRAESITEF BF ON BF.CDTIPORECE = TR.CDTIPORECE
         WHERE (TR.IDTIPORECE = '1' OR TR.CDTIPORECE = '025')
           AND TR.CDTIPORECE NOT IN (SELECT TR.CDTIPORECE
                                       FROM TIPORECE TR
                                       JOIN BANDESITEFFIL BS ON BS.CDTIPORECE = TR.CDTIPORECE
                                      WHERE BS.CDFILIAL = :CDFILIAL)
    ";

    const DELETE_CREDIT_CARD = "
        DELETE FROM CARTCREDCONS
        WHERE CDCARTCRED = :CDCARTCRED
    ";

    const SET_ALL_CREDIT_CARDS_TO_FLAG_O = "
        UPDATE CARTCREDCONS
           SET IDTPCARTCRED = 'O'
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const SET_CREDIT_CARD_TO_FLAG_P = "
        UPDATE CARTCREDCONS
           SET IDTPCARTCRED = 'P'
         WHERE CDCARTCRED = :CDCARTCRED
    ";

    const GET_AUTO_RECHARGE_DETAILS = "
        SELECT FF.CDFAMILISALD, FS.NMFAMILISALD, NVL(RA.VRMINSALDORRECAR, 0.00) AS VRMINSALDORRECAR, NVL(RA.VRRECARGARAUT, 0.00) AS VRRECARGARAUT
          FROM FAMSALDOFILI FF
          LEFT JOIN (SELECT CDFAMILISALD, VRMINSALDORRECAR, VRRECARGARAUT
                       FROM RECARGAAUTO
                      WHERE CDCLIENTE = :CDCLIENTE
                        AND CDCONSUMIDOR = :CDCONSUMIDOR) RA
                 ON RA.CDFAMILISALD = FF.CDFAMILISALD
               JOIN FAMILIASALDO FS
                 ON FS.CDFAMILISALD = FF.CDFAMILISALD
         WHERE FS.IDATIVO = 'S'
           AND FF.CDFILIAL = :CDFILIAL
           AND FF.IDPERMCARGACRED = 'S'
    ";

    const GET_AUTO_RECHARGE_INFO = "
        SELECT RA.CDFAMILISALD, RA.VRMINSALDORRECAR, RA.VRRECARGARAUT
          FROM RECARGAAUTO RA
         WHERE RA.CDCLIENTE = :CDCLIENTE
           AND RA.CDCONSUMIDOR = :CDCONSUMIDOR
           AND RA.CDFAMILISALD = :CDFAMILISALD
    ";

    const INSERT_AUTO_RECHARGE = "
        INSERT INTO RECARGAAUTO(
            CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRMINSALDORRECAR, VRRECARGARAUT
        )
        VALUES (
            :CDCLIENTE, :CDCONSUMIDOR, :CDFAMILISALD, :VRMINSALDORRECAR, :VRRECARGARAUT
        )
    ";

    const UPDATE_AUTO_RECHARGE = "
        UPDATE RECARGAAUTO
           SET VRMINSALDORRECAR = :VRMINSALDORRECAR,
               VRRECARGARAUT = :VRRECARGARAUT
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
    ";

    const GET_ALL_FILIAIS = "
        SELECT CF.CDCLIENTE, F.CDFILIAL, F.NMFILIAL, V.CDCAIXA, CX.CDLOJA, CX.NRCONFTELA FROM FILIAL F
        JOIN CLIENFILIAL CF ON CF.CDFILIAL = F.CDFILIAL
        JOIN PARAVEND P ON P.CDFILIAL = F.CDFILIAL
          AND P.CDCLIENTE = CF.CDCLIENTE
        JOIN VENDEDOR V ON V.CDVENDEDOR = P.CDVENDEDOR
          AND V.CDFILIAL = F.CDFILIAL
        JOIN CAIXA CX ON CX.CDFILIAL = F.CDFILIAL
          AND CX.CDCAIXA = V.CDCAIXA
        WHERE CF.CDCLIENTE = :CDCLIENTE
        AND V.CDCAIXA IS NOT NULL
    ";

    const GET_LAYOUT_BY_CLIENT = "
    SELECT T.CONSULTASALDO, T.CONSULTAEXTRATO, T.RECARREGACARTAO, T.BLOQUEACARTAO, T.RESTRICAOALIMENTAR, T.ATUALIZACADASTRO,
        T.TROCASENHA, T.VISUALIZACARDAPIO, T.RESTRICAOVALOR, T.FALECONOSCO, T.RECARGAAUTOCARTAO, T.EDITACARTAO, P.IDUTILBOLNUTRI
    FROM TIPOCONSCLI T, PARAVEND P
    WHERE T.CDCLIENTE = :CDCLIENTE
    AND T.CDTIPOCONS = :CDTIPOCONS
    AND P.CDFILIAL = :CDFILIAL
    ";
    
    const GET_DEFAULT_LAYOUT = "
    SELECT PN.CONSULTASALDO, PN.CONSULTAEXTRATO, PN.RECARREGACARTAO, PN.BLOQUEACARTAO, PN.RESTRICAOALIMENTAR, PN.ATUALIZACADASTRO,
        PN.TROCASENHA, PN.VISUALIZACARDAPIO, PN.RESTRICAOVALOR, PN.FALECONOSCO, PN.RECARGAAUTOCARTAO, PN.EDITACARTAO, PV.IDUTILBOLNUTRI
    FROM PARAMNOCASH PN, PARAVEND PV
    WHERE PV.CDFILIAL = :CDFILIAL
    ";

    const GET_PAYMENT_PLATFORM_BY_FILIAL = "
      SELECT IDPLATAFORMAPAG
      FROM PARAVEND
      WHERE CDFILIAL = :CDFILIAL"
    ;

    const GET_PAYMENT_PLATFORM = "
      SELECT IDPLATAFORMAPAG
      FROM PARAMGERAL"
    ;

    const GET_ONLINE_PAYMENT_INFO_BY_FILIAL = "
      SELECT IDLOJAESITEFFIL AS IDLOJAESITEF, CDLOJAESITEFFIL AS CDLOJAESITEF
      FROM PARAVEND
      WHERE CDFILIAL = :CDFILIAL
    ";

    const GET_ONLINE_PAYMENT_INFO = "
      SELECT CDLOJAESITEF, IDLOJAESITEF
        FROM PARAMGERAL
    ";

    //Nutritional Report
    const GET_FAMILY_DATA = "
      SELECT FS.CDFAMILISALD, FS.NMFAMILISALD, FF.CDVENDEDOR
        FROM FAMSALDOFILI FF
        JOIN FAMILIASALDO FS
          ON FF.CDFAMILISALD = FS.CDFAMILISALD
       WHERE CDFILIAL = :CDFILIAL
    ";

    const GET_SALESMAN_FILI = "
      SELECT CDVENDEDOR
        FROM PARAVEND
       WHERE CDFILIAL = :CDFILIAL
    ";

    const GET_SALESMAN_GENERAL = "
      SELECT CDVENDEDORDLV CDVENDEDOR
        FROM PARAMGERAL
    ";

    const GET_REGISTER = "
      SELECT CDCAIXA
        FROM VENDEDOR
       WHERE CDVENDEDOR = :CDVENDEDOR
    ";

    const GET_FAM_GROUP_PRODUCT = "
      SELECT CDGRUPPROD
        FROM FAMSALDOFILI
       WHERE CDFILIAL = :CDFILIAL
         AND CDFAMILISALD = :CDFAMILISALD
    ";

    const GET_FILI_GROUP_PRODUCT = "
      SELECT CDGRUPPROD
        FROM PARAVEND
       WHERE CDFILIAL = :CDFILIAL
    ";

    const GET_GER_GROUP_PRODUCT = "
      SELECT CDGRUPPROD
        FROM PARAMGERAL
    ";
    // -- @todo ajustar query para ficar similar a GET_PRODUCTS_SOLD
    // const GET_PRODUCTS_NUTRITIONAL = "
    //   SELECT P.CDPRODUTO, IT.CDFILIAL, IT.NRCONFTELA, IT.DSBUTTON AS NMGRUPO, IT.NRPGCONFTELA||IT.NRBUTTON AS CDGRUPO,
    //          P.NMPRODUTO, P.VRNUTRIPROD
    //     FROM ITMENUCONFTE IT
    //     JOIN PRODUTO P
    //       ON IT.CDIDENTBUTON = P.CDPRODUTO
    //    WHERE IT.NRCONFTELA = (SELECT NRCONFTELA
    //                             FROM CAIXA
    //                            WHERE CDCAIXA  = :CDCAIXA
    //                              AND CDFILIAL = :CDFILIAL
    //                          )
    //     AND IT.CDFILIAL = :CDFILIAL
    // ";
    const GET_PRODUCTS_NUTRITIONAL = "
       SELECT P.CDPRODUTO, IT.CDFILIAL, NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMGRUPO, NVL(SP.CDSUBGRPROD,'00001') CDGRUPO,
              P.NMPRODUTO, P.VRNUTRIPROD
         FROM ITMENUCONFTE IT
         JOIN PRODUTO P
           ON IT.CDIDENTBUTON = P.CDPRODUTO
    LEFT JOIN NVSUBGRPROD NG
           ON NG.CDPRODUTO = P.CDPRODUTO
    LEFT JOIN SUBGRUPPROD SP
           ON SP.CDSUBGRPROD = NG.CDSUBGRPROD
          AND SP.CDGRUPPROD = NG.CDGRUPPROD
    LEFT JOIN (SELECT CDGRUPPROD
                 FROM GRUPPROD GP
                WHERE CDGRUPPROD = :CDGRUPPROD) GP
           ON GP.CDGRUPPROD = NG.CDGRUPPROD
        WHERE IT.NRCONFTELA = (SELECT NRCONFTELA
                                 FROM CAIXA
                                WHERE CDCAIXA  = :CDCAIXA
                                  AND CDFILIAL = :CDFILIAL
                              )
         AND IT.CDFILIAL   = :CDFILIAL
         AND P.VRNUTRIPROD <> 4
     ";
    // -- @todo verificar trocar nome de NMSUBGRPROD
    // const GET_PRODUCTS_SOLD = "
    //   SELECT DISTINCT P.CDPRODUTO, P.NMPRODUTO, P.VRNUTRIPROD, NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMSUBGRPROD, SP.CDSUBGRPROD
    //     FROM EXTRATOCONS EC
    //     JOIN ITEMVENDA IV
    //       ON EC.NRSEQVENDA = IV.NRSEQVENDA
    //     JOIN PRODUTO P
    //       ON IV.CDPRODUTO = P.CDPRODUTO
    //     JOIN FAMILIASALDO FS
    //       ON EC.CDFAMILISALD = FS.CDFAMILISALD
    //     JOIN CAIXA C
    //       ON EC.CDFILIAL = C.CDFILIAL
    //     AND EC.CDCAIXA = C.CDCAIXA
    //     LEFT JOIN NVSUBGRPROD NG
    //       ON NG.CDPRODUTO = P.CDPRODUTO
    //     LEFT JOIN SUBGRUPPROD SP
    //       ON SP.CDSUBGRPROD = NG.CDSUBGRPROD
    //      AND SP.CDGRUPPROD = NG.CDGRUPPROD
    //     LEFT JOIN GRUPPROD GP
    //       ON GP.CDGRUPPROD = NG.CDGRUPPROD
    //    WHERE EC.IDTPMOVEXT = 'V'
    //      AND GP.CDGRUPPROD = :CDGRUPPROD
    // ";
    // const GET_PRODUCTS_SOLD = "
    //   SELECT DISTINCT P.CDPRODUTO, P.NMPRODUTO, P.VRNUTRIPROD, NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMSUBGRPROD, SP.CDSUBGRPROD
    //     FROM EXTRATOCONS EC
    //     JOIN ITEMVENDA IV
    //       ON EC.NRSEQVENDA = IV.NRSEQVENDA
    //     JOIN PRODUTO P
    //       ON IV.CDPRODUTO = P.CDPRODUTO
    //     JOIN FAMILIASALDO FS
    //       ON EC.CDFAMILISALD = FS.CDFAMILISALD
    //     JOIN CAIXA C
    //       ON EC.CDFILIAL = C.CDFILIAL
    //     AND EC.CDCAIXA = C.CDCAIXA
    //     LEFT JOIN NVSUBGRPROD NG
    //       ON NG.CDPRODUTO = P.CDPRODUTO
    //     LEFT JOIN SUBGRUPPROD SP
    //       ON SP.CDSUBGRPROD = NG.CDSUBGRPROD
    //      AND SP.CDGRUPPROD = NG.CDGRUPPROD
    //     LEFT JOIN GRUPPROD GP
    //       ON GP.CDGRUPPROD = NG.CDGRUPPROD
    //    WHERE TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI,'DD/MM/YYYY') AND TO_DATE(:DTFIM, 'DD/MM/YYYY')
    //      AND EC.IDTPMOVEXT = 'V'
    //      AND GP.CDGRUPPROD = :CDGRUPPROD
    //      AND IV.CDFILIAL   = :CDFILIAL
    //      AND EC.CDFAMILISALD = :CDFAMILISALD
    // ";

    const GET_PRODUCTS_SOLD = "
       SELECT P.CDPRODUTO, P.NMPRODUTO, IV.CDFILIAL, P.VRNUTRIPROD, NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMGRUPO, NVL(SP.CDSUBGRPROD,'00001') CDGRUPO
         FROM EXTRATOCONS EC
         JOIN ITEMVENDA IV
           ON EC.NRSEQVENDA = IV.NRSEQVENDA
          AND EC.CDCAIXA    = IV.CDCAIXA
          AND EC.CDFILIAL   = IV.CDFILIAL
         JOIN PRODUTO P
           ON IV.CDPRODUTO = P.CDPRODUTO
    LEFT JOIN NVSUBGRPROD NG
           ON NG.CDPRODUTO = P.CDPRODUTO
         LEFT JOIN SUBGRUPPROD SP
           ON SP.CDSUBGRPROD = NG.CDSUBGRPROD
          AND SP.CDGRUPPROD = NG.CDGRUPPROD
    LEFT JOIN (SELECT CDGRUPPROD
                 FROM GRUPPROD GP
                WHERE CDGRUPPROD = :CDGRUPPROD) GP
           ON GP.CDGRUPPROD = NG.CDGRUPPROD
        WHERE TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI,'DD/MM/YYYY') AND TO_DATE(:DTFIM, 'DD/MM/YYYY')
          AND EC.IDTPMOVEXT    = 'V'
          AND IV.CDFILIAL      = :CDFILIAL
          AND EC.CDFAMILISALD  = :CDFAMILISALD
          AND P.VRNUTRIPROD <> 4
    ";
    const GET_SHOPPING_DATA = "
       SELECT DISTINCT P.CDPRODUTO, P.NMPRODUTO, IV.CDFILIAL, P.VRNUTRIPROD, NVL(SP.NMSUBGRPROD, 'OUTROS') AS NMGRUPO, NVL(SP.CDSUBGRPROD,'00001') CDGRUPO
         FROM EXTRATOCONS EC
         JOIN ITEMVENDA IV
           ON EC.NRSEQVENDA = IV.NRSEQVENDA
          AND EC.CDCAIXA    = IV.CDCAIXA
          AND EC.CDFILIAL   = IV.CDFILIAL
         JOIN PRODUTO P
           ON IV.CDPRODUTO = P.CDPRODUTO
    LEFT JOIN NVSUBGRPROD NG
           ON NG.CDPRODUTO = P.CDPRODUTO
         LEFT JOIN SUBGRUPPROD SP
           ON SP.CDSUBGRPROD = NG.CDSUBGRPROD
          AND SP.CDGRUPPROD = NG.CDGRUPPROD
    LEFT JOIN (SELECT CDGRUPPROD
                 FROM GRUPPROD GP
                WHERE CDGRUPPROD = :CDGRUPPROD) GP
           ON GP.CDGRUPPROD = NG.CDGRUPPROD
        WHERE TRUNC(EC.DTMOVEXTCONS) BETWEEN TO_DATE(:DTINI,'DD/MM/YYYY') AND TO_DATE(:DTFIM, 'DD/MM/YYYY')
          AND EC.IDTPMOVEXT    = 'V'
          AND IV.CDFILIAL      = :CDFILIAL
          AND EC.CDFAMILISALD  = :CDFAMILISALD
          AND EC.CDCONSUMIDOR  = :CDCONSUMIDOR
          AND EC.CDCLIENTE     = :CDCLIENTE
          AND P.VRNUTRIPROD <> 4
    ";

    const GET_NOTIFICATIONS_BY_CONSUMER = "
        SELECT N.NRNOTIFICAAPP, C.NMCONSUMIDOR, N.DSNOTIFICAAPP, TO_CHAR(N.DTNOTIFICAAPP, 'DD/MM/YYYY') AS DTNOTIFICAAPP, N.IDNOTIFICAAPPLIDA
        FROM NOTIFICACAOAPP N
        JOIN CONSUMIDOR C
          ON C.CDCLIENTE = N.CDCLIENTENOTIFAPP
          AND C.CDCONSUMIDOR = N.CDCONSUMINOTIFAPP
        WHERE N.CDCLIENTENOTIFAPP = :CDCLIENTE
            AND N.CDCONSUMINOTIFAPP = :CDCONSUMIDOR
            AND N.CDTIPONOTIFICAAPP IN (SELECT CDTIPONOTIFICAAPP
                                        FROM TIPONOTIFAPP
                                        WHERE IDATIVO = 'S')
            AND N.DTNOTIFICAAPP > SYSDATE - 30
    ";

    const SET_NOTIFICATION_AS_READED = "
        UPDATE NOTIFICACAOAPP
        SET IDNOTIFICAAPPLIDA = 'S'
        WHERE NRNOTIFICAAPP = :NRNOTIFICAAPP
    ";

    const GET_NON_READED_NOTIFICATIONS_BY_CONSUMER = "
        SELECT COUNT (*) AS NRNOTIFNAOLIDA
        FROM NOTIFICACAOAPP
        WHERE CDCLIENTENOTIFAPP = :CDCLIENTE
            AND CDCONSUMINOTIFAPP = :CDCONSUMIDOR
            AND IDNOTIFICAAPPLIDA = 'N'
            AND CDTIPONOTIFICAAPP IN (SELECT CDTIPONOTIFICAAPP
                                        FROM TIPONOTIFAPP
                                        WHERE IDATIVO = 'S')
            AND DTNOTIFICAAPP > SYSDATE - 30
    ";

    const GET_RECHARGE_FAMILY_NAME = "
        SELECT NMFAMILISALD
        FROM FAMILIASALDO
        WHERE CDFAMILISALD = :CDFAMILISALD
    ";

    const SAVE_NOTIFICATION = "
        INSERT INTO NOTIFICACAOAPP
        (NRNOTIFICAAPP, CDCLIENTENOTIFAPP, CDCONSUMINOTIFAPP, CDTIPONOTIFICAAPP, DSNOTIFICAAPP, DTNOTIFICAAPP)
        VALUES
        (:NRNOTIFICAAPP, :CDCLIENTENOTIFAPP, :CDCONSUMINOTIFAPP, :CDTIPONOTIFICAAPP, :DSNOTIFICAAPP, SYSDATE)
    ";

    // Gera cardápio
    const ORACLE_PRECOS = "
        SELECT CDPRODUTO, VRPRECITEM
          FROM ITEMPRECO
         WHERE CDFILIAL = :CDFILIAL
           AND CDTABEPREC = :CDTABEPREC
           AND DTINIVGPREC = TRUNC(TO_DATE(:DTINIVGPREC, 'DD-MM-YYYY HH24:MI:SS'))
    ";

    const ORACLE_PRECOS_DIA = "
        SELECT VRPRECODIA, IDPERVALORPR, IDDESCACREPR, IDVISUACUPOM, CDTIPOCONSPD, CDPRODUTO
          FROM ITEMPRECODIA
         WHERE CDFILIAL       = :CDFILIAL
           AND CDTABEPREC     = :CDTABEPREC
           AND DTINIVGPREC    = TO_DATE(:DTINIVGPREC, 'DD/MM/YYYY HH:MI:SS')
           AND ((NRDIASEMANPR = :NRDIASEMANPR) OR (NRDIASEMANPR = 'T'))
           AND TO_CHAR(SYSDATE,'HH24')||'00' BETWEEN HRINIPRECDIA AND HRFINPRECDIA
           AND CDTIPOCONSPD = :CDTIPOCONSPD
    ";

    const CLIENTE_FILIAL = "
        SELECT CDTABEPREC, CDCFILTABPRE
          FROM CLIENFILIAL
          WHERE CDFILIAL = :CDFILIAL
          AND CDCLIENTE = :CDCLIENTE
    ";

    const EXISTE_PRECO_CLIE = "
    SELECT CDTABEPREC, CDFILTABPREC
      FROM CLIENTE
      WHERE (CDCLIENTE = :CDCLIENTE)
    ";

    const TABELA_PRECO_LOJA = "
    SELECT CDTABEPREC
      FROM LOJA
      WHERE (CDFILIAL = :CDFILIAL)
        AND (CDLOJA   = :CDLOJA)
    ";

    const PARAVEND = "
    SELECT CDTABEPREC, IDPRECDIFCOM
      FROM PARAVEND
      WHERE (CDFILIAL = :CDFILIAL)
    ";

    const TABELA_VENDA_ORACLE = "
        SELECT TO_CHAR(A.DTINIVGPREC, 'DD-MM-YYYY HH:MI:SS') AS DTINIVGPREC FROM (
            SELECT TO_TIMESTAMP(TO_CHAR(DTINIVGPREC, 'DD-MM-YYYY HH:MI:SS'), 'DD-MM-YYYY HH:MI:SS') AS DTINIVGPREC
              FROM TABEVEND
             WHERE CDFILIAL   = :CDFILIAL
               AND CDTABEPREC = :CDTABEPREC
               AND SYSDATE BETWEEN DTINIVGPREC AND DTFINVGPREC
        ) A
    ";

    const BUSCA_GRUPO_PRODUTOS = "
        SELECT IDTPBUTTON, IDTPBUTONAUX, NRBUTTON, NRBUTTONAUX,
               DSBUTTON, CDIDENTBUTON, NRCOLORTEXT, NRCOLORBACK,
               NRPGCONFTELA, NRPGCONFTAUX, DSMESSAGEBUT, DSIMAGEMBUT,
               DSENDEIMG
          FROM (SELECT AM.IDTPBUTTON, AM.IDTPBUTONAUX, AM.NRBUTTON, AM.NRBUTTONAUX,
                       AM.DSBUTTON, AM.CDIDENTBUTON, AM.NRCOLORTEXT, AM.NRCOLORBACK,
                       AM.NRPGCONFTELA, AM.NRPGCONFTAUX, AM.DSMESSAGEBUT, AM.DSIMAGEMBUT,
                       AM.DSENDEIMG
                  FROM ITMENUCONFTE AM
                 WHERE AM.CDFILIAL   = :CDFILIAL
                   AND AM.NRCONFTELA = :NRCONFTELA) MESA
         WHERE IDTPBUTTON = '2'
         ORDER BY NRPGCONFTELA, NRBUTTON
    ";

    const BUSCA_SUBGRUPO_PRODUTOS = "
        SELECT IDTPBUTTON, IDTPBUTONAUX, NRBUTTON, NRBUTTONAUX,
               DSBUTTON, CDIDENTBUTON, NRCOLORTEXT, NRCOLORBACK,
               NRPGCONFTELA, NRPGCONFTAUX, DSMESSAGEBUT, DSIMAGEMBUT,
               DSENDEIMG
          FROM ITMENUCONFTE
         WHERE IDTPBUTTON = 'I'
           AND CDFILIAL = :CDFILIAL
           AND NRCONFTELA = :NRCONFTELA
    ";

    const BUSCA_PRODUTOS_ORACLE = "
        SELECT IDTPBUTTON, IDTPBUTONAUX, NRBUTTON,
               NRBUTTONAUX, DSBUTTON, CDIDENTBUTON,
               NRCOLORTEXT, NRCOLORBACK, NRPGCONFTELA,
               NRPGCONFTAUX, DSMESSAGEBUT, DSIMAGEMBUT,
               IDSOLLOCIMP, IDPESAPROD, CDARVPROD,
               CDPRODINTE, CDBARPRODUTO, IDTIPOPROD,
               IDTIPOCOMPPROD, IDIMPPRODUTO, DTINIVGPROMOC, DTFINVGPROMOC,
               CDPRODUTO, IDCONTROLAREFIL, CDFILIAL, NRCONFTELA, DSENDEIMG,
               IDTPBUTONAUX2, NRBUTTONAUX2, NRPGCONFTAUX2, DSPRODVENDA, 'N' AS IDPRODBLOQ,
               DSADICPROD
          FROM (SELECT AM.IDTPBUTTON, AM.IDTPBUTONAUX, AM.NRBUTTON, AM.NRBUTTONAUX,
                       AM.DSBUTTON, AM.CDIDENTBUTON, AM.NRCOLORTEXT, AM.NRCOLORBACK,
                       AM.NRPGCONFTELA, AM.NRPGCONFTAUX, AM.DSMESSAGEBUT,
                       AM.DSIMAGEMBUT, PR.IDSOLLOCIMP, PR.IDPESAPROD, PR.CDARVPROD,
                       PR.CDPRODINTE, PR.CDBARPRODUTO, PR.IDTIPOPROD, PR.IDTIPOCOMPPROD,
                       PR.IDIMPPRODUTO, PR.DTINIVGPROMOC, PR.DTFINVGPROMOC, PR.CDPRODUTO,
                       PR.IDCONTROLAREFIL, AM.CDFILIAL, AM.NRCONFTELA, NVL(AM.DSENDEIMG, PR.DSENDEIMG) AS DSENDEIMG, AM.IDTPBUTONAUX2,
                       AM.NRBUTTONAUX2, AM.NRPGCONFTAUX2, PR.DSPRODVENDA, PR.DSADICPROD

                  FROM ITMENUCONFTE AM

                  JOIN PRODUTO PR
                    ON AM.CDIDENTBUTON = PR.CDPRODUTO
                  JOIN CONFTELA CF
                    ON AM.CDFILIAL = CF.CDFILIAL
                   AND AM.NRCONFTELA = CF.NRCONFTELA

                 WHERE AM.CDFILIAL = :CDFILIAL
                   AND AM.NRCONFTELA = :NRCONFTELA
                   AND PR.CDPRODUTO NOT IN (SELECT CDPRODUTO

                                              FROM PRODBLOQVND

                                             WHERE CDFILIAL = :CDFILIAL
                                               AND CDLOJA = :CDLOJA
                                               AND (NRDIASEMANABLOQ = 'T'
                                                    OR  NRDIASEMANABLOQ = :NRDIASEMANABLOQ)) ) MESA
          WHERE IDTPBUTTON = '1'
          AND IDTPBUTONAUX IN ('2', 'I')
          ORDER BY NRPGCONFTAUX, NRBUTTONAUX, NRPGCONFTELA, NRBUTTON
    ";

    const BUSCA_OBSERVACOES_PRODUTO = "
        SELECT PR.CDPRODUTO, PR.CDOCORR, OC.DSOCORR, OC.CDGRPOCOR,
               OC.IDCONTROLAOBS
          FROM GRUPOCOR GR, PRODOCORRE PR, LOJA LJ, OCORRENCIA OC
         WHERE LJ.CDFILIAL  = :CDFILIAL
           AND LJ.CDLOJA    = :CDLOJA
           AND GR.CDGRPOCOR = LJ.CDGRPOCORPED
           AND PR.CDGRPOCOR = GR.CDGRPOCOR
           AND GR.CDGRPOCOR = OC.CDGRPOCOR
           AND PR.CDOCORR   = OC.CDOCORR
           AND PR.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                      FROM PRODBLOQVND
                                     WHERE CDFILIAL = :CDFILIAL
                                       AND CDLOJA = :CDLOJA
                                       AND (NRDIASEMANABLOQ = 'T'
                                            OR  NRDIASEMANABLOQ = :NRDIASEMANABLOQ))
    ";

    const ITEM_PRECO_ORACLE = "
        SELECT NVL(I.VRPRECITEM, 0) AS PRECO,
               NVL(I.VRPRECITEMCL, 0) AS PRECOCLIE,
               NVL(I.VRPRESUGITEM, 0) AS PRECOSUGER,
               I.IDPRECVARIA, P.NMPRODUTO
          FROM ITEMPRECO I JOIN PRODUTO P
                             ON I.CDPRODUTO = P.CDPRODUTO
         WHERE I.CDFILIAL = :CDFILIAL
           AND I.CDTABEPREC = :CDTABEPREC
           AND DTINIVGPREC = TO_DATE(:DTINIVGPREC, 'DD/MM/YYYY HH:MI:SS')
           AND I.CDPRODUTO = :CDPRODUTO
    ";

    const SQL_GET_IMP_PRODUTOS = "
        SELECT PA.CDAMBIENTE, IL.NRSEQIMPRLOJA, IL.NMIMPRLOJA
          FROM PRODAMBIENTE PA JOIN IMPRLOJA IL
                                 ON IL.CDFILIAL      = PA.CDFILIAL
                                AND IL.CDLOJA        = PA.CDLOJA
                                AND IL.NRSEQIMPRLOJA = PA.NRSEQIMPRLOJA
         WHERE PA.CDFILIAL   = :CDFILIAL
           AND PA.CDLOJA     = :CDLOJA
           AND PA.CDPRODUTO  = :CDPRODUTO
           AND PA.NRCONFTELA = :NRCONFTELA
    ";

    const SQL_GRUPOS_PROMO_INT_FILI = "
        SELECT G.CDGRUPROMOC, P.NMGRUPROMOC, G.QTPRGRUPPROMFIL AS QTPRGRUPPROMOC
          FROM GRUPROMOCPRFIL G JOIN GRUPROMOC P
                                  ON G.CDGRUPROMOC = P.CDGRUPROMOC
         WHERE G.CDPRODPROMOCAO = :CDIDENTBUTON
           AND G.CDFILIAL = :CDFILIAL
    ";

    const SQL_GRUPOS_PROMO_INT = "
        SELECT G.CDGRUPROMOC, P.NMGRUPROMOC, G.QTPRGRUPPROMOC
          FROM GRUPROMOCPROD G JOIN GRUPROMOC P
                                 ON G.CDGRUPROMOC = P.CDGRUPROMOC
         WHERE G.CDPRODPROMOCAO = :CDIDENTBUTON
    ";

    const ORACLE_PRODUTOS_PROMO_INT = "
        SELECT DP.CDPRODPROMOCAO, PP.CDGRUPROMOC, PP.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, P.IDIMPPRODUTO,
               NVL(DP.IDPERVALORDES, 'P') AS IDPERVALORDES,  '0' AS IDCTRLMODIFY,
               NVL(DP.VRDESPRODPROMOC, 0) AS VRDESPRODPROMOC,
               NVL(DP.IDAPLICADESCPR, 'T') AS IDAPLICADESCPR,
               'N' AS IDPRODBLOQ, P.DSPRODVENDA, PP.DSENDEIMGPROMO,
               PP.DSAPELIDOMOB, PP.NRORDPROMOPR, P.DSADICPROD
          FROM PRODUTO P JOIN PRODGRUPROMOC PP
                           ON P.CDPRODUTO = PP.CDPRODUTO
                          AND PP.CDGRUPROMOC = :CDGRUPROMOC
                    LEFT JOIN DESGRUPROMOCPR DP
                           ON DP.CDPRODPROMOCAO = :CDIDENTBUTON
                          AND DP.CDGRUPROMOC = PP.CDGRUPROMOC
                          AND DP.CDPRODUTO = PP.CDPRODUTO
         WHERE P.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                              FROM PRODBLOQVND
                                             WHERE CDFILIAL = :CDFILIAL
                                               AND CDLOJA = :CDLOJA
                                               AND (NRDIASEMANABLOQ = 'T'
                                                    OR  NRDIASEMANABLOQ = :NRDIASEMANABLOQ))
        ORDER BY NVL(PP.NRORDPROMOPR , 99999), PP.CDPRODUTO
    ";

    const ORACLE_PRODUTOS_PROMO_INT_FILI = "
        SELECT DP.CDPRODPROMOCAO, PP.CDGRUPROMOC, PP.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, P.IDIMPPRODUTO,
               NVL(DP.IDPERVALDESFIL, 'P') AS IDPERVALORDES, '0' AS IDCTRLMODIFY,
               NVL(DP.VRDESPRPROMOFIL, 0) AS VRDESPRODPROMOC,
               NVL(DP.IDAPLICADESCPRFI, 'T') AS IDAPLICADESCPR,
               'N' AS IDPRODBLOQ, P.DSPRODVENDA, PP.DSENDEIMGPROMO,
               PP.DSAPELIDOMOB, PP.NRORDPROMOPR, P.DSADICPROD
          FROM PRODUTO P JOIN PRODGRUPROMOC PP
                           ON P.CDPRODUTO = PP.CDPRODUTO
                          AND PP.CDGRUPROMOC = :CDGRUPROMOC
                    LEFT JOIN DESGRUPROMPRFIL DP
                           ON DP.CDPRODPROMOCAO = :CDIDENTBUTON
                          AND DP.CDGRUPROMOC = PP.CDGRUPROMOC
                          AND DP.CDPRODUTO = PP.CDPRODUTO
          WHERE P.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                              FROM PRODBLOQVND
                                             WHERE CDFILIAL = :CDFILIAL
                                               AND CDLOJA = :CDLOJA
                                               AND (NRDIASEMANABLOQ = 'T'
                                                    OR  NRDIASEMANABLOQ = :NRDIASEMANABLOQ))
        ORDER BY NVL(PP.NRORDPROMOPR , 99999), PP.CDPRODUTO
    ";

    const GET_COMBO_PRODUCTS = "
        SELECT AM.IDTPBUTTON, AM.IDTPBUTONAUX, AM.NRBUTTON, AM.NRBUTTONAUX,
               AM.DSBUTTON, AM.CDIDENTBUTON, AM.NRCOLORTEXT, AM.NRCOLORBACK,
               AM.NRPGCONFTELA, AM.NRPGCONFTAUX, AM.DSMESSAGEBUT, AM.DSIMAGEMBUT,
               'N' AS IDSOLLOCIMP, 'N' AS IDPESAPROD, NULL AS CDARVPROD, NULL AS CDPRODINTE,
               NULL AS CDBARPRODUTO, NULL AS IDTIPOPROD, '0' AS IDTIPOCOMPPROD, '1' AS IDIMPPRODUTO,
               NULL AS DTINIVGPROMOC, NULL AS DTFINVGPROMOC, NULL AS CDPRODUTO, 'N' AS IDCONTROLAREFIL,
               AM.CDFILIAL, AM.NRCONFTELA, AM.DSENDEIMG, AM.IDTPBUTONAUX2,
               AM.NRBUTTONAUX2, AM.NRPGCONFTAUX2, 'N' AS IDPRODBLOQ,
               AM.NRLIMPRODCOM, NULL AS DSPRODVENDA, L.IDTIPCOBRA
          FROM ITMENUCONFTE AM
          JOIN LOJA L ON L.CDFILIAL = AM.CDFILIAL
         WHERE AM.CDFILIAL = :CDFILIAL
           AND L.CDLOJA = :CDLOJA
           AND AM.NRCONFTELA = :NRCONFTELA
           AND AM.IDTPBUTTON = 'B'
    ";

    const BUSCA_PRODUTOS_COMBO_ORACLE = "
        SELECT P.CDPRODUTO AS CDPRODUTO, P.IDIMPPRODUTO, 'T' AS IDAPLICADESCPR, 'P' AS IDPERVALORDES,
               NVL(I.DSBUTTON, P.NMPRODUTO) AS NMPRODUTO, '.000' AS VRDESPRODPROMOC,
               'N' AS IDPRODBLOQ, 'COMBO' AS NMGRUPROMOC, NVL(I.CDIDENTBUTON, P.CDPRODUTO) AS CDIDENTBUTON,
               NVL(I.DSBUTTON, P.NMPRODUTO) AS DSOCORR, P.CDARVPROD AS CDOCORR, P.CDARVPROD,
               P.IDTIPOPROD, P.IDTIPOCOMPPROD, NVL(I.DSBUTTON, P.NMPRODUTO) AS NOME, P.DSPRODVENDA AS DESCRIPTION
          FROM PRODUTO P LEFT JOIN ITMENUCONFTE I
                                ON P.CDPRODUTO = I.CDIDENTBUTON
                               AND I.CDFILIAL = :CDFILIAL
                               AND I.NRCONFTELA = :NRCONFTELA
         WHERE P.IDTIPOPROD = :IDTIPOPROD
        AND P.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                  FROM PRODBLOQVND
                                 WHERE CDFILIAL = :CDFILIAL
                                   AND CDLOJA = :CDLOJA
                                   AND (NRDIASEMANABLOQ = 'T'
                                        OR  NRDIASEMANABLOQ = :NRDIASEMANABLOQ))
    ";

    const TIPO_CONSUMIDOR = "
        SELECT CDTIPOCONS
          FROM CONSUMIDOR
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const FERIADO = "
        SELECT DTFERIFILI
          FROM FERIFILI
         WHERE CDFILIAL = :CDFILIAL
           AND DTFERIFILI = :DTFERIFILI
    ";

    const ITEM_PRECO_DIA_ORACLE = "
        SELECT VRPRECODIA, IDPERVALORPR, IDDESCACREPR, IDVISUACUPOM, CDTIPOCONSPD
          FROM ITEMPRECODIA
          WHERE CDFILIAL       = :CDFILIAL
            AND CDTABEPREC     = :CDTABEPREC
            AND DTINIVGPREC    = TO_DATE(:DTINIVGPREC, 'DD/MM/YYYY HH:MI:SS')
            AND CDPRODUTO      = :CDPRODUTO
            AND CDPRPAITABPR   = :CDPRPAITABPR
            AND NRDIASEMANPR   = :NRDIASEMANPR
            AND ((CDTIPOCONSPD = :CDTIPOCONSPD) OR (CDTIPOCONSPD = 'T'))
            AND TO_CHAR(SYSDATE,'HH24')||'00' BETWEEN HRINIPRECDIA AND HRFINPRECDIA
    ";

    const SAVE_AUTO_RECHARGE_LOG = "
        INSERT INTO LOGCREDCONSUMIDOR
        (CDCLIENTE, CDCONSUMIDOR, CDTPOPERACAO, DSLOGCREDCONS, DTOPERACAO)
        VALUES
        (:CDCLIENTE, :CDCONSUMIDOR, '1', :DSLOGCREDCONS, SYSDATE)
    ";

    const SAVE_NEW_CARD_LOG = "
        INSERT INTO LOGCREDCONSUMIDOR
        (CDCLIENTE, CDCONSUMIDOR, CDTPOPERACAO, DSLOGCREDCONS, DTOPERACAO)
        VALUES
        (:CDCLIENTE, :CDCONSUMIDOR, '2', :DSLOGCREDCONS, SYSDATE)
    ";

    // QUERYS EVOLUI SALDO

    const GET_SALDO_ALL_FAMILIES = "
        SELECT C.CDCLIENTE, C.NRORG, C.CDCONSUMIDOR,C.CDFAMILISALD,F.DTMOVEXTCONS, F.VRSALDCONEXT AS VRSALDCONEXT, C.NRORG
          FROM (SELECT C.CDCLIENTE, C.NRORG, C.CDCONSUMIDOR,F.CDFAMILISALD
                  FROM CONSUMIDOR C, FAMILIASALDO F
                 WHERE ((CDCLIENTE = :CDCLIENTE) OR (:TCDCLIENTE = 'T' ))
                   AND ((CDCONSUMIDOR = :CDCONSUMIDOR) OR (:TCDCONSUMIDOR = 'T'))
               ) C
          LEFT JOIN (SELECT E.CDCLIENTE,E.CDCONSUMIDOR,E.CDFAMILISALD,E.DTMOVEXTCONS, E.VRSALDCONEXT, E.NRORG
                       FROM EXTRATOCONS E, (SELECT E.CDCLIENTE,E.CDCONSUMIDOR,E.CDFAMILISALD,D.DTMOVEXTCONS, MAX(E.NRSEQMOVEXT) AS NRSEQMOVEXT, E.NRORG
                                              FROM EXTRATOCONS E, (SELECT CDCLIENTE,CDCONSUMIDOR,CDFAMILISALD,MAX(DTMOVEXTCONS) AS DTMOVEXTCONS, NRORG
                                                                     FROM EXTRATOCONS
                                                                    WHERE ((CDCLIENTE = :CDCLIENTE) OR (:TCDCLIENTE = 'T'))
                                                                      AND ((CDCONSUMIDOR = :CDCONSUMIDOR) OR (:TCDCONSUMIDOR = 'T'))
                                                                      AND (DTMOVEXTCONS < :DTMOVEXTCONS)
                                                                    GROUP BY CDCLIENTE,CDCONSUMIDOR,CDFAMILISALD, NRORG
                                                                  ) D
                                              WHERE E.CDCLIENTE    = D.CDCLIENTE
                                                AND E.CDCONSUMIDOR = D.CDCONSUMIDOR
                                                AND E.CDFAMILISALD = D.CDFAMILISALD
                                                AND E.DTMOVEXTCONS = D.DTMOVEXTCONS
                                                AND E.NRORG        = D.NRORG
                                              GROUP BY E.CDCLIENTE,E.CDCONSUMIDOR,E.CDFAMILISALD,D.DTMOVEXTCONS, E.NRORG
                                           ) DT
                      WHERE E.CDCLIENTE     = DT.CDCLIENTE
                        AND E.CDCONSUMIDOR  = DT.CDCONSUMIDOR
                        AND E.CDFAMILISALD  = DT.CDFAMILISALD
                        AND E.DTMOVEXTCONS  = DT.DTMOVEXTCONS
                        AND E.NRSEQMOVEXT   = DT.NRSEQMOVEXT
                        AND E.NRORG         = DT.NRORG
                    ) F
                 ON C.CDCLIENTE    = F.CDCLIENTE
                AND C.CDCONSUMIDOR = F.CDCONSUMIDOR
                AND C.CDFAMILISALD = F.CDFAMILISALD
                AND C.NRORG        = F.NRORG
              ORDER BY C.CDCLIENTE,C.CDCONSUMIDOR,C.CDFAMILISALD
    ";

    const GET_SALDO_FOR_FAMILIES = "
        SELECT CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, DTMOVEXTCONS, NRSEQMOVEXT, IDTPMOVEXT, DSOPEEXTCONS, VRMOVEXTCONS, VRSALDCONEXT, 0 AS SALDOFINAL, NRORG
          FROM EXTRATOCONS
         WHERE CDCLIENTE     = :CDCLIENTE
           AND CDCONSUMIDOR  = :CDCONSUMIDOR
           AND CDFAMILISALD  = :CDFAMILISALD
           AND DTMOVEXTCONS >= :DTMOVEXTCONS
           AND NRORG         = :NRORG
         ORDER BY CDFAMILISALD, DTMOVEXTCONS
    ";

    const ATUALIZA_MOVIMENTACAO_EXTRATO = "
        UPDATE EXTRATOCONS
           SET VRSALDCONEXT = :SALDOFINAL
         WHERE CDCLIENTE    = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
           AND DTMOVEXTCONS = :DTMOVEXTCONS
           AND NRSEQMOVEXT  = :NRSEQMOVEXT
           AND NRORG        = :NRORG
    ";

    const GET_VERIFICA_SALDO = "
        SELECT CDCLIENTE
          FROM SALDOCONS
         WHERE CDCLIENTE  = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
           AND NRORG = :NRORG
    ";

    const INSERT_SALDO_CONS = "
        INSERT INTO SALDOCONS (CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRSALDCONFAM, NRORG)
        VALUES (:CDCLIENTE, :CDCONSUMIDOR, :CDFAMILISALD, :VRSALDCONFAM, :NRORG)
    ";

    const ATUALIZA_SALDO_CONS = "
        UPDATE SALDOCONS
           SET VRSALDCONFAM = :VRSALDCONFAM
         WHERE CDCLIENTE = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND CDFAMILISALD = :CDFAMILISALD
           AND NRORG   = :NRORG
    ";

    const GET_CONSUMER_NRORG = "
        SELECT NRORG
        FROM CONSUMIDOR
        WHERE CDCLIENTE = :CDCLIENTE
        AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";
    
    // to use with procedure
    const GET_TRANSACTION_DATE_P = "
        SELECT TO_CHAR(MIN(DTMOVEXTCONS), 'DD/MM/YYYY HH24:MI:SS') AS DTMOVEXTCONS FROM EXTRATOCONS
        WHERE CDCLIENTE = :CDCLIENTE
        AND CDCONSUMIDOR = :CDCONSUMIDOR
        AND CDFAMILISALD = :CDFAMILISALD
    ";

    // to use with function
    const GET_TRANSACTION_DATE_F = "
        SELECT MIN(DTMOVEXTCONS) AS DTMOVEXTCONS FROM EXTRATOCONS
        WHERE CDCLIENTE = :CDCLIENTE
        AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    // FIM EVOLUI SALDO
    
    const REGISTER_USER = "
        INSERT INTO CONSUMIDOR
            (CDCLIENTE, CDCONSUMIDOR, NMCONSUMIDOR, CDIDCONSUMID, NMLOGINCONS, CDSENHACONSMD5, NMRESPCONS, DSEMAILCONS, NRCPFRESPCON, NRTELECONS,
            NRCELULARCONS, DSENDECONS, NRENDECONS, DSCOMPLENDECONS, DSREFERENDECONS, NRCEPCONS, CDPAIS, SGESTADO,
            CDMUNICIPIO, NMBAIRCONS, CDBAIRRO, CDTIPOCONS, CDCCUSCLIE, IDATUCONSUMI, IDSITCONSUMI, IDCONSUMIDOR,
            CDVENDEDOR, IDTPVENDACONS, IDIMPCPFCUPOM, IDCADCONFLIBCON, IDPERCONSPRODEX, IDTPSELMANHA, IDTPSEALMOCO, IDTPSELTARDE, IDCRACHAMESTRE)
        VALUES
            (:CDCLIENTE, :CDCONSUMIDOR, :NMCONSUMIDOR, :CDIDCONSUMID, :NMLOGINCONS, :CDSENHACONSMD5, :NMRESPCONS, :DSEMAILCONS, :NRCPFRESPCON, :NRTELECONS,
            :NRCELULARCONS, :DSENDECONS, :NRENDECONS, :DSCOMPLENDECONS, :DSREFERENDECONS, :NRCEPCONS, :CDPAIS, :SGESTADO,
            :CDMUNICIPIO, :NMBAIRCONS, :CDBAIRRO, :CDTIPOCONS, :CDCCUSCLIE, :IDATUCONSUMI, :IDSITCONSUMI, :IDCONSUMIDOR,
            :CDVENDEDOR, :IDTPVENDACONS, :IDIMPCPFCUPOM, :IDCADCONFLIBCON, :IDPERCONSPRODEX, :IDTPSELMANHA, :IDTPSEALMOCO, :IDTPSELTARDE, :IDCRACHAMESTRE)
    ";
    
    const GET_CONSUMER_BY_CPF = "
		SELECT CO.CDCLIENTE, CO.CDCONSUMIDOR, CO.NMCONSUMIDOR, CO.NRCPFRESPCON,
			   CO.NRRGCONSUMID, CO.DSEMAILCONS, CO.DTNASCCONS, CO.NRCEPCONS,
			   CO.CDPAIS, CO.SGESTADO, MU.CDMUNICIPIO, MU.NMMUNICIPIO, BA.CDBAIRRO,
			   BA.NMBAIRRO, CO.DSENDECONS, CO.NRENDECONS, CO.DSCOMPLENDECONS,
			   CO.NRTELECONS, CO.NRCELULARCONS, CO.DSREFERENDECONS
		  FROM CONSUMIDOR CO, MUNICIPIO MU, BAIRRO BA
		 WHERE CO.NRCPFRESPCON = :NRCPFRESPCON
		   AND CO.CDCLIENTE   = :CDCLIENTE 
		   AND CO.CDPAIS      = MU.CDPAIS(+)
		   AND CO.SGESTADO    = MU.SGESTADO(+)
		   AND CO.CDMUNICIPIO = MU.CDMUNICIPIO(+)
		   AND CO.CDPAIS      = BA.CDPAIS(+)
		   AND CO.SGESTADO    = BA.SGESTADO(+)
		   AND CO.CDMUNICIPIO = BA.CDMUNICIPIO(+)
		   AND CO.CDBAIRRO    = BA.CDBAIRRO(+)
	";
	
	const GET_TIPO_CONS = "
		SELECT CDTIPOCONS
		  FROM PARAVEND
		 WHERE CDFILIAL = :CDFILIAL
	";
	
	const GET_CUS_CLIE = "
		SELECT CDCCUSCLIE
		  FROM PARAVEND
		 WHERE CDFILIAL = :CDFILIAL"
  ;
  
  // INICIO - SALES EMAIL SERVICE

  const GET_LAST_RUN_DATE = "
      SELECT TO_CHAR(DTLOGEMAILVEND, 'DD/MM/YYYY HH24:MI:SS') DTLOGEMAILVEND
        FROM LOGEMAILVENDA
    ORDER BY DTLOGEMAILVEND DESC
  ";

  const GET_SALES = "
      SELECT EC.NRSEQVENDA, EC.VRMOVEXTCONS, EC.VRSALDCONEXT, EC.CDCLIENTE, EC.CDCONSUMIDOR, CO.DSEMAILCONS, CO.NMRESPCONS,
              CO.NMCONSUMIDOR, EC.CDFAMILISALD, FS.NMFAMILISALD, TO_CHAR(EC.DTMOVEXTCONS,'DD/MM/YYYY') AS DTMOVEXTCONS, EC.CDFILIAL,
              DECODE(CL.IDEXBTPNOMECLIE,'F', CL.NMFANTCLIE, CL.NMRAZSOCCLIE) AS NMFANTCLIE, PR.NMPRODUTO,
              IV.QTPRODVEND, IV.VRUNITVEND, IV.VRDESITVEND

        FROM EXTRATOCONS EC
        JOIN CLIENTE CL 
          ON EC.CDCLIENTE = CL.CDCLIENTE
        JOIN CONSUMIDOR CO 
          ON EC.CDCONSUMIDOR = CO.CDCONSUMIDOR
          AND EC.CDCLIENTE = CO.CDCLIENTE
        JOIN ITEMVENDA IV
          ON EC.CDFILIAL = IV.CDFILIAL
          AND EC.CDCAIXA = IV.CDCAIXA
          AND EC.NRSEQVENDA = IV.NRSEQVENDA
        JOIN PRODUTO PR
          ON IV.CDPRODUTO = PR.CDPRODUTO
        JOIN FAMILIASALDO FS
          ON EC.CDFAMILISALD = FS.CDFAMILISALD

        WHERE EC.IDTPMOVEXT = 'V'
          AND EC.DTMOVEXTCONS >= TO_DATE(:DTULTEXEC, 'DD/MM/YYYY HH24:MI:SS')

    ORDER BY EC.DTMOVEXTCONS DESC, EC.NRSEQVENDA
  ";

  const SAVE_LOG_IN_DATABASE = "
      INSERT INTO LOGEMAILVENDA
      (NRLOGEMAILVEND, DSLOGEMAILVEND, DTLOGEMAILVEND, IDCONCLEMAILVD)
      VALUES
      (:NRLOGEMAILVEND, :DSLOGEMAILVEND, SYSDATE, 'N')
  ";

  const UPDATE_LOG_IN_DATABASE = "
      UPDATE LOGEMAILVENDA
          SET DSLOGEMAILVEND = :DSLOGEMAILVEND, IDCONCLEMAILVD = :IDCONCLEMAILVD
        WHERE NRLOGEMAILVEND = :NRLOGEMAILVEND
  ";

  // FIM - SALES EMAIL SERVICE
  
  const GET_USE_CVV = "
    SELECT NVL(PV.IDUTCVVCARTARM,PG.IDUTCVVCARTARM) IDUTCVVCARTARM
      FROM PARAVEND PV, PARAMGERAL PG
     WHERE PV.CDFILIAL = :CDFILIAL
  ";
  
  const GET_BONUS_RECHARGE_ORIGIN = "
      SELECT VRCARGACREDITO, VRBONUSCREDITO, VRSALDCONSBONUS,
             IDPERIODOBONUS, CDTIPORECE, QTRECARGASMES
        FROM TIPOCONSFILI
       WHERE CDFILIAL = :CDFILIAL
         AND CDTIPOCONS = :CDTIPOCONS
         AND CDTIPORECEORIGEM = :CDTIPORECEORIGEM
         AND IDRECEBEBONUS = 'S'
  ";  
  
  const GET_BONUS_RECHARGE = "
      SELECT VRCARGACREDITO, VRBONUSCREDITO, VRSALDCONSBONUS,
             IDPERIODOBONUS, CDTIPORECE, QTRECARGASMES
        FROM TIPOCONSFILI
       WHERE CDFILIAL = :CDFILIAL
         AND CDTIPOCONS = :CDTIPOCONS
         AND IDRECEBEBONUS = 'S'
  ";  
  
  // AUTOMATIC RECHARGE QUERYS //
  
  const GET_CONSUMERS = "
        SELECT R.CDCLIENTE, R.CDCONSUMIDOR, R.CDFAMILISALD, R.VRMINSALDORRECAR,
               R.VRRECARGARAUT, NVL(S.VRSALDCONFAM, 0) AS VRSALDCONFAM,
               C.DSTOKEN, C.CARTCREDMD5, C.NRULTNUM, B.IDESITEF, T.CDTIPORECE, CON.HABENVEMAIL, C.NMTITULAR
          FROM RECARGAAUTO R
          LEFT JOIN (SELECT CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRSALDCONFAM
                       FROM SALDOCONS) S
            ON S.CDCLIENTE = R.CDCLIENTE
           AND S.CDCONSUMIDOR = R.CDCONSUMIDOR
           AND S.CDFAMILISALD = R.CDFAMILISALD
          LEFT JOIN CARTCREDCONS C ON C.CDCLIENTE = R.CDCLIENTE
                                  AND C.CDCONSUMIDOR = R.CDCONSUMIDOR
                                  AND C.IDTPCARTCRED = 'P'
          LEFT JOIN BANDEIRAESITEF B ON B.NRSEQBANDEIRA = C.NRSEQBANDEIRA
          LEFT JOIN TIPORECE T ON T.CDTIPORECE = B.CDTIPORECE
          JOIN CONSUMIDOR CON ON R.CDCONSUMIDOR = CON.CDCONSUMIDOR AND R.CDCLIENTE = CON.CDCLIENTE
         WHERE R.VRMINSALDORRECAR >= 0
           AND R.VRRECARGARAUT > 0
           AND NVL(S.VRSALDCONFAM, 0) < R.VRMINSALDORRECAR
           AND CON.IDSITCONSUMI = '1'
    ";

    const GET_CONSUMERS_DEFAULT_CREDIT_CART = "
        SELECT CART.DSTOKEN, B.IDESITEF, CART.NRULTNUM
          FROM CARTCREDCONS CART
          JOIN CONSUMIDOR CONS ON CART.CDCONSUMIDOR = CONS.CDCONSUMIDOR AND CART.CDCLIENTE = CART.CDCLIENTE
          JOIN BANDEIRAESITEF B ON CART.NRSEQBANDEIRA = B.NRSEQBANDEIRA
          JOIN TIPORECE T ON B.CDTIPORECE = T.CDTIPORECE
         WHERE CART.IDTPCARTCRED = 'P' AND CONS.CDCLIENTE = :CDCLIENTE AND CONS.CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const GET_FILIAL = "
        SELECT PV.CDFILIAL, NVL(PV.IDLOJAESITEFFIL,PG.IDLOJAESITEF) IDLOJAESITEFFIL, NVL(PV.CDLOJAESITEFFIL,PG.CDLOJAESITEF) CDLOJAESITEFFIL
          FROM PARAVEND PV, PARAMGERAL PG, CLIENFILIAL CF, CLIENTE CL
         WHERE PV.CDCLIENTE = CF.CDCLIENTE
           AND PV.CDFILIAL = CF.CDFILIAL
           AND PV.CDCLIENTE = CL.CDCLIENTE
           AND CF.CDCLIENTE = CL.CDCLIENTE
           AND PV.IDFILUTSITE = 'S'
           AND CF.IDPERMVENDAFOS = 'S'
           AND CL.CDCLIENTE = :CDCLIENTE
    ";

    const GET_CONSUMER_CPF = "
        SELECT NRCPFRESPCON
        FROM CONSUMIDOR
        WHERE CDCLIENTE = :CDCLIENTE
          AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const GET_CARD_INFO = "
        SELECT C.DSTOKEN, C.CARTCREDMD5, C.NRULTNUM, B.IDESITEF, T.CDTIPORECE, C.NMTITULAR
        FROM CARTCREDCONS C
        JOIN BANDEIRAESITEF B ON B.NRSEQBANDEIRA = C.NRSEQBANDEIRA
        JOIN TIPORECE T ON T.CDTIPORECE = B.CDTIPORECE
        JOIN (SELECT CDCLIENTE, CDCONSUMIDOR
            FROM CONSUMIDOR
            WHERE NRCPFRESPCON = :NRCPFRESPCON) S
          ON C.CDCLIENTE = S.CDCLIENTE AND C.CDCONSUMIDOR = S.CDCONSUMIDOR
        WHERE C.CARTCREDMD5 IS NOT NULL
        AND ROWNUM = 1
    ";
    
    // --------------------------- //
}
