<?php

namespace Odhen\API\Service;

class ImpressaoNFCE {
	protected $entityManager;
	protected $impressaoUtil;
	protected $util;

	public function __construct(
        \Doctrine\ORM\EntityManager $entityManager,
        \Odhen\API\Lib\ImpressaoUtil $impressaoUtil,
        \Odhen\API\Util\Util $util) {

        $this->entityManager = $entityManager;
        $this->impressaoUtil = $impressaoUtil;
        $this->util 	     = $util;
    }

    public function fillNfceInfo($nfceData, &$nfceInfo){
    	$nfceInfo['NRNOTAFISCALCE'] = $nfceData['NRNOTAFISCALCE'];
    	$nfceInfo['CDSERIENFCE'] = $nfceData['CDSERIENFCE'];
    	$nfceInfo['DTEMISSAONFCE'] = $nfceData['DTEMISSAONFCE'];
    	$nfceInfo['NRACESSONFCE'] = $nfceData['NRACESSONFCE'];
    	$nfceInfo['CDSENHAPED'] = $nfceData['CDSENHAPED'];
    	$nfceInfo['DSQRCODENFCE'] = $nfceData['DSQRCODENFCE'];
    	$nfceInfo['WSLINKQRCODENFC'] = $nfceData['WSLINKQRCODENFC'];
    	$nfceInfo['WSLINKQRCODENFC'] = $nfceData['WSLINKQRCODENFC'];
    	$nfceInfo['IDIMPLOGONF'] = $nfceData['IDIMPLOGONF'];
    	$nfceInfo['IDIMPTXSERV'] = $nfceData['IDIMPTXSERV'];
    	$nfceInfo['IDIMPCNPJCLIE'] = $nfceData['IDIMPCNPJCLIE'];
    	$nfceInfo['DSMENSCPFCUP'] = $nfceData['DSMENSCPFCUP'];
    	$nfceInfo['DSOBSCUPFIS'] = $nfceData['DSOBSCUPFIS'];
    	$nfceInfo['nmloja'] = $nfceData['NMLOJA'];
    	$nfceInfo['nmcaixa'] = $nfceData['NMCAIXA'];
    }

    public function imprimeDanfeNFCE($nfceInfo, $filialInfo, $items){
		$nfceData = self::getNFCEDataToPrint($nfceInfo['nrAcessoNFCE']);
        if($nfceData['error'] == false){
			self::fillNfceInfo($nfceData['nfceData'], $nfceInfo);
            $paravendData = self::getParavendData($filialInfo['cdfilial']);
            if($paravendData['error'] == false){
                $stImpSaldoCupom = $paravendData['paravendData']['IDIMPSALDOCUPOM'];
                $dadosImpressora = self::getDadosImpressora($filialInfo['cdfilial'], $filialInfo['cdcaixa'], $filialInfo['nrorg']);
                if($dadosImpressora['error'] == false){
                	$texto = '';
                	$retornoMontaString = $this->montaStringCupom($nfceData['nfceData'], $filialInfo, $nfceInfo, $dadosImpressora['dadosImpressora']);
                    $texto = $retornoMontaString['texto'];
                    $portaUsbKiosk = $retornoMontaString['portaUsbKiosk'];
                    $this->impressaoUtil->imprimeTexto($texto, $dadosImpressora['dadosImpressora']['IDMODEIMPRES'], $portaUsbKiosk);
                    if ($dadosImpressora['dadosImpressora']['IDMODEIMPRES'] != 20) {
	                    $this->impressaoUtil->cortaPapel($dadosImpressora['dadosImpressora']['IDMODEIMPRES'], $portaUsbKiosk);
	                }
            		$this->impressaoUtil->fechaPorta($dadosImpressora['dadosImpressora']['IDMODEIMPRES'], $portaUsbKiosk);

            		$result = array(
            			'error' => false
            		);
            		return $result;
				} else {
					$result = $dadosImpressora;
				}
			} else {
					$result = $paravendData;
			}
		} else {
			$result = $nfceData;
		}
		return $result;
	}


	public function montaStringCupom($nfceData, $filialInfo, $nfceInfo, $dadosImpressora){
		$printerParams = $this->impressaoUtil->buscaParametrosImpressora($dadosImpressora['IDMODEIMPRES']);
		$resposta = $this->impressaoUtil->iniciarPorta($dadosImpressora['IDMODEIMPRES'], $dadosImpressora['CDPORTAIMPR']);
		$portaUsbKiosk = $resposta['portaUsbKiosk'];

		$texto = '';
		$texto = $this->montaCabecalhoCupom($printerParams, $filialInfo);
		$texto = $this->montaTituloCupom($texto, $printerParams);
		$texto = $this->montaInfoProdutosCupom($texto, $printerParams, $filialInfo, $nfceInfo);
		$texto = $this->montaInfoPagamentoCupom($texto, $filialInfo, $nfceInfo, $printerParams);
		$texto = $this->montaInfoStatusCupom($texto, $nfceInfo, $printerParams);
		$texto = $this->montaInfoDadosCupom($texto, $nfceInfo, $printerParams);
		$texto = $this->montaInfoConsumidorCupom($texto, $filialInfo, $nfceInfo, $printerParams, $nfceData);
		$texto = $this->montaQRCODECupom($texto, $nfceInfo, $dadosImpressora, $printerParams, $portaUsbKiosk);
		$texto = $this->montaInfoTributosCupom($texto, $nfceInfo, $printerParams);
		$texto = $this->montaProdutosCancelados($texto, $nfceInfo, $filialInfo, $printerParams);
		$texto = $this->montaRodapeCupom($texto, $nfceInfo, $filialInfo, $printerParams);
		return array(
			'texto' => $texto,
			'portaUsbKiosk' => $portaUsbKiosk
		);
	}

	public function montaCabecalhoCupom($printerParams, $filialInfo){
		$texto = '';
		$texto .= substr($filialInfo['nmrazsocfili'], 0, $printerParams['largura']-26);
		$texto .= ' '.'CNPJ: '.$filialInfo['nrinsjurfili'].'.';
		$texto .= substr($filialInfo['nrinsjurfili'],3 ,3).'.';
		$texto .= substr($filialInfo['nrinsjurfili'], 6, 3).'/';
		$texto .= substr($filialInfo['nrinsjurfili'], 9, 4).'-';
		$texto .= substr($filialInfo['nrinsjurfili'], 13, 2);
		$texto = $this->impressaoUtil->centraliza($printerParams, $texto);
		$texto .= $printerParams['comandoEnter'];
		$texto .= $filialInfo['dsendefili'].', '.$filialInfo['nmbairfili'].', '.$filialInfo['nmmunicipio'].' - '.$filialInfo['sgestado'];
		$texto = $this->impressaoUtil->centraliza($printerParams, $texto).$printerParams['comandoEnter'];
		$texto .= $this->impressaoUtil->imprimeLinha($printerParams, $texto);
		return $texto;

	}

	public function montaTituloCupom($texto, $printerParams){
		$texto .= $this->impressaoUtil->centraliza($printerParams, 'DOCUMENTO AUXILIAR DA NOTA FISCAL DE CONSUMIDOR ELETRONICA') . $printerParams['comandoEnter'];
		$texto .= $this->impressaoUtil->imprimeLinha($printerParams, $texto);
		return $texto;
	}

	public function montaInfoProdutosCupom($texto, $printerParams, $filialInfo, $nfceInfo){
		$colunasInfo = 'Item | Codigo | Descricao | UN | Qtde | Vl.Unit | Vl.Tot ';
		$texto .= $this->impressaoUtil->centraliza($printerParams, $colunasInfo). $printerParams['comandoEnter'];
            $texto .= $printerParams['comandoEnter'];
			$productsNFCE = $this->getInfoProducts($filialInfo, $nfceInfo);
            foreach($productsNFCE as $product){
            	$tituloProduto = $product['NRSEQUITVEND'].' '.$product['CDARVPROD'].' '.substr($product['NMPRODUTO'], 0, 29);
                $texto .= str_pad($tituloProduto, $printerParams['largura'] - 2, ' ', STR_PAD_RIGHT);
                $texto .= str_pad($product['SGUNIDADE'], $printerParams['largura'] - 2).$printerParams['comandoEnter'];
                $quantProduto = $this->impressaoUtil->formataNumero(floatval($product['QTPRODVEND']), 2);
                $vrProduto = $this->impressaoUtil->formataNumero(floatval($product['VRUNITVEND']), 2);
                $totalProduto = $this->impressaoUtil->formataNumero(floatval($product['VRTOTITEM']), 2);
                $texto .= str_pad($quantProduto . ' X ' . $vrProduto . ' = ' . $totalProduto, $printerParams['largura'], ' ', STR_PAD_LEFT) . $printerParams['comandoEnter'];
                if ($product['VRTOTACRE'] > 0) {
	            	$vrAcrescimo = $this->impressaoUtil->formataNumero(floatval($product['VRTOTACRE']), 2);
	                $texto .= str_pad('ACRESCIMO NO ITEM '.$product['NRSEQUITVEND'].' + ' . $vrAcrescimo, $printerParams['largura'], STR_PAD_LEFT) . $printerParams['comandoEnter'];
                }
                if ($product['VRTOTDESC'] > 0){
                	$vrDesconto =  $this->impressaoUtil->formataNumero(floatval($product['VRTOTDESC']), 2);
                	$texto .= str_pad('DESCONTO NO ITEM '. $product['NMPRODUTO'].' = '. $vrDesconto, $printerParams['largura'], ' ', STR_PAD_RIGHT) . $printerParams['comandoEnter'].$printerParams['comandoEnter'];
                }
			}
            $texto .= str_pad('-----------------------',$printerParams['largura'], ' ', STR_PAD_LEFT) . $printerParams['comandoEnter'];
			$totalVenda = $this->impressaoUtil->formataNumero(floatval($nfceInfo['totalVenda']), 2);
            $texto .= str_pad('Vr. Total Pago: = ' . $totalVenda, $printerParams['largura'], ' ', STR_PAD_LEFT) . $printerParams['comandoEnter'];
            $texto .= str_pad('Valor de Troco: = ' . $this->impressaoUtil->formataNumero(floatval($productsNFCE[0]['VRSAIDA']),2),$printerParams['largura'], ' ', STR_PAD_LEFT) . $printerParams['comandoEnter'];

            $texto .= $this->impressaoUtil->imprimeLinha($printerParams, $texto);
            return $texto;
	}

	public function getInfoProducts($filialInfo, $nfceInfo){
		$paramsToGetProducts = array(
				':CDFILIAL'		=>		$filialInfo['cdfilial'],
				':CDCAIXA'		=>		$filialInfo['cdcaixa'],
				':NRSEQVENDA'	=>		$nfceInfo['nrseqvenda']
			);
		return $this->entityManager->getConnection()->fetchAll(self::GET_PRODUCTS_TO_PRINT_NFCE, $paramsToGetProducts);
	}

	public function montaInfoPagamentoCupom($texto, $filialInfo, $nfceInfo, $printerParams){
		$infoPaymentNFCE = $this->getInfoPayment($filialInfo, $nfceInfo);
        $quantidadeProdutos  = $infoPaymentNFCE[0]['QTDETOTAL'];
        $vrVenda = floatval($infoPaymentNFCE[0]['VRTOTITEM']);
        $totalAcrescimo  = floatval($infoPaymentNFCE[0]['VRTOTACRE']);
        $totalDescontos  = floatval($infoPaymentNFCE[0]['VRTOTDESC']);
        $totalVenda = $vrVenda + $totalAcrescimo - $totalDescontos;

        $textoQuantidade = str_pad('QTD. TOTAL DE ITENS',$printerParams['largura'] / 2) . str_pad($quantidadeProdutos,$printerParams['largura']/2, ' ', STR_PAD_LEFT) . $printerParams['comandoEnter'];

        $texto .= $textoQuantidade;
        $vrVenda = $this->impressaoUtil->formataNumero(floatval($vrVenda), 2);
        $totalVenda = $this->impressaoUtil->formataNumero(floatval($totalVenda), 2);
        $texto .= str_pad('VALOR TOTAL R$'     ,$printerParams['largura']/2) . str_pad($vrVenda, $printerParams['largura']/2, ' ', STR_PAD_LEFT) . $printerParams['comandoEnter'];
        if ($totalAcrescimo > 0.00 ){
        	$textoAcrescimo = $this->impressaoUtil->formataNumero(floatval($totalAcrescimo), 2);
           $texto .= str_pad('ACRESCIMOS R$'   ,$printerParams['largura']/2) . str_pad($textoAcrescimo, $printerParams['largura']/2, ' ', STR_PAD_LEFT) . $printerParams['comandoEnter'];
        }
        if (floatval($totalDescontos)> 0.00 ){
        	$textoDesconto = $this->impressaoUtil->formataNumero(floatval($totalDescontos), 2);
           $texto .= str_pad('DESCONTOS R$'    ,$printerParams['largura']/2) . str_pad($textoDesconto, $printerParams['largura']/2, ' ', STR_PAD_LEFT) . $printerParams['comandoEnter'];
        }
        $texto .= str_pad('VALOR A PAGAR R$'   ,$printerParams['largura']/2) . str_pad($totalVenda, $printerParams['largura']/2, ' ', STR_PAD_LEFT) . $printerParams['comandoEnter'];

        foreach($infoPaymentNFCE as $valores){
			$texto .= str_pad($valores['NMTIPORECE'],$printerParams['largura'] / 2) . str_pad($this->impressaoUtil->formataNumero(floatval($valores['VRMOVIVEND']), 2),$printerParams['largura'] / 2, ' ', STR_PAD_LEFT) . $printerParams['comandoEnter'];
		}
        $texto .= $this->impressaoUtil->imprimeLinha($printerParams, $texto);
        return $texto;
	}

	public function getInfoPayment($filialInfo, $nfceInfo){
		$paramsToVerifyQuery = array(
                ':CDFILIAL'   => $filialInfo['cdfilial'],
                ':CDCAIXA'    => $filialInfo['cdcaixa'],
                ':NRSEQVENDA' => $nfceInfo['nrseqvenda']
            );
            $paymentInfo = $this->entityManager->getConnection()->fetchAll(self::GET_INFO_PAYMENT_NFCE, $paramsToVerifyQuery);
        return $paymentInfo;
	}

	public function montaInfoStatusCupom($texto, $nfceInfo, $printerParams){
		if ($nfceInfo['tpAmb'] == '1') {
			if ($nfceInfo['IDSTATUSNFCE'] != 'A') {
				$texto .= $this->impressaoUtil->centraliza($printerParams,'EMITIDA EM CONTINGENCIA',$printerParams['largura']) . $printerParams['comandoEnter'];
				$texto .= $this->impressaoUtil->imprimeLinha($printerParams, $texto);
			}
		} else {
			if ($nfceInfo['IDSTATUSNFCE'] != 'A') {
				$texto .= $this->impressaoUtil->centraliza($printerParams, 'EMITIDA EM CONTINGENCIA') . $printerParams['comandoEnter'];
			} else {
				$texto .= $this->impressaoUtil->centraliza($printerParams, 'EMITIDA EM AMBIENTE DE HOMOLOGACAO - SEM VALOR FISCAL') . $printerParams['comandoEnter'];
			}
			$texto .= $this->impressaoUtil->imprimeLinha($printerParams, $texto);
		}
		return $texto;
	}

	public function montaInfoDadosCupom($texto, $nfceInfo, $printerParams){
		$texto .= $this->impressaoUtil->centraliza($printerParams, 'Numero '.$nfceInfo['NRNOTAFISCALCE'].' Serie '.$nfceInfo['CDSERIENFCE']) . $printerParams['comandoEnter'];
        $texto .= $this->impressaoUtil->centraliza($printerParams, 'Emissao '. $nfceInfo['DTEMISSAONFCE'].' - Via Consumidor') . $printerParams['comandoEnter'] . $printerParams['comandoEnter'];
        $texto .= $this->impressaoUtil->centraliza($printerParams, 'Consulte pela Chave de Acesso em') . $printerParams['comandoEnter'];
        $texto .= $this->impressaoUtil->centraliza($printerParams, $nfceInfo['WSLINKQRCODENFC']) . $printerParams['comandoEnter'] . $printerParams['comandoEnter'];
        $texto .= $this->impressaoUtil->centraliza($printerParams,
           substr($nfceInfo['NRACESSONFCE'],01,4).' '.substr($nfceInfo['NRACESSONFCE'],05,4).' '.substr($nfceInfo['NRACESSONFCE'],09,4).' '.substr($nfceInfo['NRACESSONFCE'],13,4).' '.
           substr($nfceInfo['NRACESSONFCE'],17,4).' '.substr($nfceInfo['NRACESSONFCE'],21,4).' '.substr($nfceInfo['NRACESSONFCE'],25,4).' '.substr($nfceInfo['NRACESSONFCE'],29,4).' '.
           substr($nfceInfo['NRACESSONFCE'],33,4).' '.substr($nfceInfo['NRACESSONFCE'],37,4).' '.substr($nfceInfo['NRACESSONFCE'],41,4)) . $printerParams['comandoEnter'];
        if ($nfceInfo['IDSTATUSNFCE'] == 'A') {
           $texto .= $this->impressaoUtil->centraliza($printerParams, 'Protocolo de Autorizacao: ' . $nfceInfo['NRPROTOCOLONFCE']) . $printerParams['comandoEnter'];
		}
		$texto .= $this->impressaoUtil->imprimeLinha($printerParams, $texto);
		return $texto;
	}

	public function getInfoConsumer($nfceInfo, $filialInfo){
		$paramsToConsumer = array(
			':CDFILIAL'   => $filialInfo['cdfilial'],
			':CDCAIXA'    => $filialInfo['cdcaixa'],
			':NRSEQVENDA' => $nfceInfo['nrseqvenda']
		);
        $infoConsumer = $this->entityManager->getConnection()->fetchAssoc(self::GET_CONSUMER_SALE, $paramsToConsumer);
        return $infoConsumer;
	}

	public function montaInfoConsumidorCupom($texto, $filialInfo, $nfceInfo, $printerParams, $nfceData){
		$infoConsumer = $this->getInfoConsumer($nfceInfo, $filialInfo);
        if (!empty($infoConsumer['NRINSCRCONS'])){
			if ($nfceData['IDIMPCNPJCLIE'] == 'S'){
				if ($infoConsumer['IDTPIJURCLIE'] == 'J' || $infoConsumer['IDTPIJURCLIE'] == 'I') {
					if (!empty($infoConsumer['NRINSJURCLIE'])) {
						$texto .= $this->impressaoUtil->centraliza($printerParams, 'CPF/CNPJ: ' . $this->util->aplicaMascaraCpfCnpj($infoConsumer['NRINSJURCLIE'])) . $printerParams['comandoEnter'];
						$texto .= $this->impressaoUtil->centraliza($printerParams, strtoupper($infoConsumer['NMFANTCLIE'])) . $printerParams['comandoEnter'];
					}
			  } else {
				$texto .= $this->impressaoUtil->centraliza($printerParams, 'CPF/CNPJ: ' . $this->util->aplicaMascaraCpfCnpj($infoConsumer['NRINSCRCONS'])) . $printerParams['comandoEnter'];
                 if (!empty($infoConsumer['NMCONSVEND'])){
					$texto .= $this->impressaoUtil->centraliza($printerParams, strtoupper($infoConsumer['NMCONSVEND'])) . $printerParams['comandoEnter'];
				 } else if (!empty($infoConsumer['NMCONSUMIDOR'])){
					$texto .= $this->impressaoUtil->centraliza($printerParams, strtoupper($infoConsumer['NMCONSUMIDOR'])) . $printerParams['comandoEnter'];
				 } else {
					$texto .= $this->impressaoUtil->centraliza($printerParams, strtoupper('CONSUMIDOR FINAL')) . $printerParams['comandoEnter'];
				 }
			  }
		   } else {
              $texto .= $this->impressaoUtil->centraliza($printerParams, 'CPF/CNPJ: ' . $this->util->aplicaMascaraCpfCnpj($infoConsumer['NRINSCRCONS'])) . $printerParams['comandoEnter'];
              if (!empty($infoConsumer['NMCONSVEND'])){
				$texto .= $this->impressaoUtil->centraliza($printerParams, strtoupper($infoConsumer['NMCONSVEND'])) . $printerParams['comandoEnter'];
			  } else if (!empty($infoConsumer['NMCONSUMIDOR'])){
				$texto .= $this->impressaoUtil->centraliza($printerParams, strtoupper($infoConsumer['NMCONSUMIDOR'])) . $printerParams['comandoEnter'];
			  } else {
				$texto .= $this->impressaoUtil->centraliza($printerParams, strtoupper('CONSUMIDOR FINAL')) . $printerParams['comandoEnter'];
			  }
		   	}

		} else {
			$texto .= $this->impressaoUtil->centraliza($printerParams, 'CONSUMIDOR NAO IDENTIFICADO') . $printerParams['comandoEnter'];
		}
        $texto .= $this->impressaoUtil->imprimeLinha($printerParams, $texto);
        return $texto;
	}

	public function montaQRCODECupom($texto, $nfceInfo, $dadosImpressora, $printerParams, $portaUsbKiosk){
		$this->impressaoUtil->imprimeTexto($texto, $dadosImpressora['IDMODEIMPRES'], $portaUsbKiosk);
        $this->impressaoUtil->configuraCodigoBarras($dadosImpressora['IDMODEIMPRES'], 60, 2, 2, 0, 174);
        $this->impressaoUtil->imprimeQrCode($dadosImpressora['IDMODEIMPRES'], $nfceInfo['DSQRCODENFCE'], $portaUsbKiosk);
        $texto = $printerParams['comandoEnter'];
        return $texto;
	}

	public function montaInfoTributosCupom($texto, $nfceInfo, $printerParams){
		$texto .= $this->impressaoUtil->imprimeLinha($printerParams, $texto);
        $texto .= $this->impressaoUtil->centraliza($printerParams, 'Informacao dos Tributos Totais Incidentes') . $printerParams['comandoEnter'];
        $texto .= $this->impressaoUtil->centraliza($printerParams, '(Lei Federal 12.741/2012)      R$ '.$this->impressaoUtil->formataNumero(floatval($nfceInfo['VRTOTTRIBIBPT']), 2)) . $printerParams['comandoEnter'];
        $texto .= $this->impressaoUtil->imprimeLinha($printerParams, $texto);
        return $texto;
	}

	public function getCanceledProducts($nfceInfo, $filialInfo){
		$canceledProductsParams = array(
			':CDFILIAL'  => $filialInfo['cdfilial'],
			':CDCAIXA'   => $filialInfo['cdcaixa'],
			':NRSEQVENDA'=> $nfceInfo['nrseqvenda']
		);
		$canceledProducts = $this->entityManager->getConnection()->fetchAll(self::GET_CANCELED_PRODUCTS, $canceledProductsParams);
		return $canceledProducts;
	}

	public function montaProdutosCancelados($texto, $nfceInfo, $filialInfo, $printerParams){
	    $canceledProducts = $this->getCanceledProducts($nfceInfo, $filialInfo);
        if (!empty($canceledProducts)){
		   $stItCanc = '';
           $stItCanc = $stItCanc . 'Itens Cancelados: '.$printerParams['comandoEnter'];
		   foreach($canceledProducts as $canceled){
				$texto .= $stItCanc . $canceled['NRSEQITVENDC'] . ' ' . $canceled['CDPRODUTO'] . ' ' . $canceled['NMPRODUTO'] . ' - ' . $canceled['QTPRODVENDC'] . ' ' . $canceled['SGUNIDADE'] . $printerParams['comandoEnter'];
		   }
		}
		return $texto;
	}

	public function montaRodapeCupom($texto, $nfceInfo, $filialInfo, $printerParams){
		$texto .= $this->impressaoUtil->centraliza($printerParams, date('d/m/Y') . ' ' . $printerParams['comandoEnter'] . $printerParams['comandoEnter']);
        $texto .= 'Filial: '.$filialInfo['cdfilial'].' '.$filialInfo['nmfilial'] . $printerParams['comandoEnter'];
        $texto .= '  Loja: '.$filialInfo['cdloja'  ].' '.$nfceInfo['nmloja'] . $printerParams['comandoEnter'];
        $texto .= ' Caixa: '.$filialInfo['cdcaixa' ].' '.$nfceInfo['nmcaixa'] . $printerParams['comandoEnter'].$printerParams['comandoEnter'];
		if (!empty($nfceInfo['DSOBSCUPFIS'])){
            $texto .= $nfceInfo['DSOBSCUPFIS'] . $printerParams['comandoEnter'].$printerParams['comandoEnter'];
        }
        $texto .= $this->impressaoUtil->centraliza($printerParams, 'SENHA: ' . $nfceInfo['CDSENHAPED'], 24) . $printerParams['comandoEnter'];
		$texto .= $printerParams['comandoEnter'] . $printerParams['comandoEnter'] . $printerParams['comandoEnter'] . $printerParams['comandoEnter'];
		return $texto;
	}

    public function getNFCEDataToPrint($nrAcessoNFCE){
		try {
			$paramsToNFCeData = array(
    			':NRACESSONFCE' => $nrAcessoNFCE
    		);
    		$nfceData = $this->entityManager->getConnection()->fetchAssoc(self::GET_NFCE_TO_PRINT, $paramsToNFCeData);
    		$result = array(
    			'error'=> false,
    			'nfceData' => $nfceData
    		);
		} catch(\Exception $e){
			$result = array(
				'error'=> true,
				'message' => $e->getMessage()
			);
		}
		return $result;
	}

	public function getParavendData($CDFILIAL){
		try{
			$paramsToParavendData = array(
				':CDFILIAL' => $CDFILIAL
			);
			$paravendData = $this->entityManager->getConnection()->fetchAssoc(self::GET_PARAVEND_DATA_TO_PRINT, $paramsToParavendData);
			$result = array(
				'error'=> false,
				'paravendData' => $paravendData
			);
		} catch(\Exception $e){
			$result = array(
				'error'=> true,
				'message' => $e->getMessage()
			);
		}
		return $result;
	}

	public function getDadosImpressora($CDFILIAL, $CDCAIXA, $NRORG){
		try{
			$paramsToPrinterData = array(
				'CDFILIAL' => $CDFILIAL,
				'CDCAIXA' => $CDCAIXA,
				'NRORG' => $NRORG
			);
			$dadosImpressora = $this->entityManager->getConnection()->fetchAssoc(self::BUSCA_DADOS_IMPRESSORA, $paramsToPrinterData);
			$result = array(
				'error' => false,
				'dadosImpressora' => $dadosImpressora
			);
		} catch(\Exception $e){
			$result = array(
				'error'=> true,
				'message' => 'Impressora não parametrizada para o caixa.'
			);
		}
		return $result;
	}

	const GET_NFCE_TO_PRINT = "
		SELECT DISTINCT FI.NMRAZSOCFILI, FI.NRINSJURFILI, FI.NMFILIAL,
		EF.DSENDEFILI, EF.NMBAIRFILI, MU.SGESTADO, MU.NMMUNICIPIO,
		VE.CDFILIAL, VE.CDCAIXA, VE.NRSEQVENDA, VE.IDTPAMBNFCE, VE.IDSTATUSNFCE,
		VE.NRNOTAFISCALCE, VE.CDSERIENFCE, VE.DTEMISSAONFCE, VE.NRACESSONFCE,
		VE.NRPROTOCOLONFCE, VE.CDSENHAPED, DSQRCODENFCE, WE.WSLINKQRCODENFC,
		IP.VRTOTTRIBIBPT, CX.DSOBSCUPFIS, CX.DSMENSCPFCUP, CX.NMCAIXA,
		IL.NRSEQIMPRLOJA, IL.CDPORTAIMPR, IM.IDMODEIMPRES, LJ.CDLOJA,
		LJ.NMLOJA, PV.IDIMPLOGONF, PV.NRPOSNVBEMA, PV.NRPOSNV1EPSON,
		PV.NRPOSNV2EPSON, PV.IDIMPTXSERV, LJ.IDIMPCNPJCLIE
    	FROM VENDA VE
    	JOIN ENDEFILI EF
    	        ON EF.CDFILIAL = VE.CDFILIAL
    	JOIN MUNICIPIO MU
    	        ON EF.CDPAIS = MU.CDPAIS
    	        AND EF.SGESTADO = MU.SGESTADO
    	        AND EF.CDMUNICIPIO = MU.CDMUNICIPIO
    	JOIN FILIAL FI
    	        ON FI.CDFILIAL = VE.CDFILIAL
    	JOIN WEBSERVICE WE
    	        ON WE.CDPAIS = EF.CDPAIS
    	        AND WE.SGESTADO = EF.SGESTADO
    	        AND WE.IDAMBIENTE = VE.IDTPAMBNFCE
    	JOIN ITVENDAIMPOS IP
    	        ON IP.CDFILIAL = VE.CDFILIAL
    	        AND IP.CDCAIXA = VE.CDCAIXA
    	        AND IP.NRSEQVENDA = VE.NRSEQVENDA
    	JOIN CAIXA CX
    	        ON CX.CDFILIAL = VE.CDFILIAL
    	        AND CX.CDCAIXA = VE.CDCAIXA
    	JOIN IMPRLOJA IL
    	        ON IL.CDFILIAL = CX.CDFILIAL
    	        AND IL.CDLOJA = CX.CDLOJA
    	        AND IL.NRSEQIMPRLOJA = CX.NRSEQIMPRLOJA3
    	JOIN IMPRESSORA IM
    	        ON IL.CDIMPRESSORA = IM.CDIMPRESSORA
    	JOIN PARAVEND PV
    	        ON FI.CDFILIAL = PV.CDFILIAL
    	JOIN LOJA LJ
    	        ON LJ.CDFILIAL = CX.CDFILIAL
    	        AND LJ.CDLOJA = CX.CDLOJA
    	WHERE
    	    VE.NRACESSONFCE = :NRACESSONFCE
    	    AND EF.IDTPENDEFILI = 'P'
    	    AND WE.IDSERVICO = 'NFC'"
	;

	const GET_PARAVEND_DATA_TO_PRINT = "
		SELECT P.CDSITUCRT, PV.IDIMPSALDOCUPOM
		FROM FILIAL F
		JOIN EMPRESA E
			ON E.CDEMPRESA = F.CDEMPRESA
		JOIN PARAMEMPRESA P
			ON P.CDEMPRESA = E.CDEMPRESA
		JOIN PARAVEND PV ON PV.CDFILIAL  = F.CDFILIAL
		WHERE
			F.CDFILIAL  = :CDFILIAL
	";

	const GET_PRODUCTS_TO_PRINT_NFCE = "
		SELECT
        IV.NRSEQUITVEND, IV.QTPRODVEND, IV.VRUNITVEND, IV.VRUNITVENDCL, IM.IDTPIMPOSFIS, IP.VRPEALPRODIT, ROUND((IV.QTPRODVEND*(IV.VRUNITVEND + IV.VRUNITVENDCL)),2,1 ) AS VRTOTITEM, (IV.VRACRITVEND-ISNULL(IV.VRRATTXSERV,0)) AS VRTOTACRE, (IV.VRDESITVEND) AS VRTOTDESC,
		ISNULL(VE.VRTXSEVENDA,0) AS VRTXSEVENDA, PR.CDPRODUTO, ISNULL(PR.CDBARPRODUTO, PR.CDARVPROD) AS CDARVPROD,
        PR.NMPRODUTO, PR.SGUNIDADE,
        SUM(CASE MC.IDTIPOMOVIVE
            WHEN 'E' THEN MC.VRMOVIVEND
            WHEN 'T' THEN MC.VRMOVIVEND
            ELSE 0
        END) AS VRENTRADA,
        SUM(CASE MC.IDTIPOMOVIVE
            WHEN 'S' THEN MC.VRMOVIVEND
            ELSE 0
        END) AS VRSAIDA
		FROM
			VENDA VE
		JOIN
			ITEMVENDA IV
				ON IV.CDFILIAL   = VE.CDFILIAL
				AND IV.CDCAIXA    = VE.CDCAIXA
				AND IV.NRSEQVENDA = VE.NRSEQVENDA
		JOIN
			PRODUTO PR
				ON PR.CDPRODUTO  = IV.CDPRODUTO
		JOIN
			MOVCAIXA MC
				ON MC.CDFILIAL   = VE.CDFILIAL
				AND MC.CDCAIXA    = VE.CDCAIXA
				AND MC.NRSEQVENDA = VE.NRSEQVENDA
		JOIN
			ITVENDAIMPOS IP
				ON IP.CDFILIAL   = VE.CDFILIAL
				AND IP.CDCAIXA    = VE.CDCAIXA
				AND IP.NRSEQVENDA = VE.NRSEQVENDA
				AND IP.NRSEQUITVEND = IV.NRSEQUITVEND
		JOIN
			IMPOSTO IM
				ON IM.CDIMPOSTO  = IP.CDIMPOSTO
		WHERE
			VE.CDFILIAL   = :CDFILIAL
			AND VE.CDCAIXA    = :CDCAIXA
			AND VE.NRSEQVENDA = :NRSEQVENDA
		GROUP BY
			IV.NRSEQUITVEND, IV.QTPRODVEND, IV.VRUNITVEND, IV.VRUNITVENDCL, IV.VRACRITVEND, IV.VRRATTXSERV, IV.VRDESITVEND, VE.VRTXSEVENDA,
			PR.CDPRODUTO, PR.CDBARPRODUTO, PR.CDARVPROD, PR.NMPRODUTO, PR.SGUNIDADE, IM.IDTPIMPOSFIS, IP.VRPEALPRODIT
		ORDER BY
			IV.NRSEQUITVEND
		";

	const GET_INFO_PAYMENT_NFCE = "
		SELECT
			COUNT(*) AS QTDETOTAL, SUM(ROUND(IV.QTPRODVEND*(IV.VRUNITVEND+IV.VRUNITVENDCL),2 ,1)) AS VRTOTITEM,
			CONVERT(VARCHAR(10), CONVERT(DECIMAL(10,2), SUM(IV.VRACRITVEND - ISNULL(IV.VRRATTXSERV,0)))) AS VRTOTACRE, CONVERT(VARCHAR(10), CONVERT(DECIMAL(10,2),SUM(IV.VRDESITVEND))) AS VRTOTDESC,
			AA.NMTIPORECE, AA.VRMOVIVEND, AA.IDTIPORECE, CONVERT(VARCHAR(10), CONVERT(DECIMAL(10,2),ISNULL(VE.VRTXSEVENDA,0))) AS VRTXSEVENDA
		FROM VENDA VE, ITEMVENDA IV,
			(SELECT E.NMTIPORECE, E.IDTIPORECE, (E.VRENTRADA-ISNULL(S.VRSAIDA,0)) AS VRMOVIVEND
			FROM (SELECT MC.CDFILIAL, MC.CDCAIXA, MC.NRSEQVENDA,TR.CDTIPORECE, TR.NMTIPORECE,
						TR.CDTIPOTROCO, TR.IDTIPORECE, SUM(MC.VRMOVIVEND)AS VRENTRADA
				FROM MOVCAIXA MC, TIPORECE TR
				WHERE MC.CDFILIAL  =:CDFILIAL
					AND MC.CDCAIXA   =:CDCAIXA
					AND MC.NRSEQVENDA=:NRSEQVENDA
					AND TR.CDTIPORECE=MC.CDTIPORECE
					AND MC.IDTIPOMOVIVE IN ('E','T')
				GROUP BY MC.CDFILIAL, MC.CDCAIXA, MC.NRSEQVENDA, TR.CDTIPORECE, TR.NMTIPORECE, TR.CDTIPOTROCO, TR.IDTIPORECE) E
					LEFT JOIN
							(SELECT MC.CDFILIAL, MC.CDCAIXA, MC.NRSEQVENDA, TR.CDTIPORECE,
									TR.NMTIPORECE, TR.CDTIPOTROCO, TR.IDTIPORECE,
									SUM(MC.VRMOVIVEND) AS VRSAIDA
							FROM MOVCAIXA MC, TIPORECE TR
							WHERE MC.CDFILIAL  =:CDFILIAL
								AND MC.CDCAIXA   =:CDCAIXA
								AND MC.NRSEQVENDA=:NRSEQVENDA
								AND TR.CDTIPORECE=MC.CDTIPORECE
								AND MC.IDTIPOMOVIVE IN ('S')
							GROUP BY MC.CDFILIAL, MC.CDCAIXA, MC.NRSEQVENDA,
									TR.CDTIPORECE, TR.NMTIPORECE, TR.CDTIPOTROCO, TR.IDTIPORECE) S
					ON E.CDFILIAL=S.CDFILIAL
					AND E.CDCAIXA=S.CDCAIXA
					AND E.NRSEQVENDA=S.NRSEQVENDA
					AND (E.CDTIPORECE=CASE E.CDTIPOTROCO WHEN NULL THEN S.CDTIPORECE ELSE S.CDTIPOTROCO END)
					) AA
			WHERE VE.CDFILIAL  =:CDFILIAL
				AND VE.CDCAIXA   =:CDCAIXA
				AND VE.NRSEQVENDA=:NRSEQVENDA
				AND IV.CDFILIAL  =VE.CDFILIAL
				AND IV.CDCAIXA   =VE.CDCAIXA
				AND IV.NRSEQVENDA=VE.NRSEQVENDA
				GROUP BY AA.NMTIPORECE, AA.VRMOVIVEND, VE.VRTXSEVENDA, AA.IDTIPORECE
		";

	const GET_CONSUMER_SALE = "
		SELECT
				VE.CDFILIAL, VE.CDCAIXA, VE.NRSEQVENDA, VE.DTENTRVENDA, VE.NRNOTAFISCALCE,
				VE.NRACESSONFCE, VE.NRINSCRCONS, VE.NMCONSVEND, VE.CDCLIENTE, VE.CDCONSUMIDOR,
				CO.NMCONSUMIDOR, CO.NRCPFRESPCON, CL.IDTPIJURCLIE, CL.NRINSJURCLIE, CO.VRMAXDEBCONS,
				CO.VRMAXCREDCONS, CO.VRMESUBCONS, CL.NMFANTCLIE
		FROM
				CLIENTE CL
				JOIN VENDA VE ON VE.CDCLIENTE = CL.CDCLIENTE
				LEFT JOIN CONSUMIDOR CO
					ON VE.CDCLIENTE = CO.CDCLIENTE
					AND VE.CDCONSUMIDOR = CO.CDCONSUMIDOR
		WHERE
				(VE.CDFILIAL   = :CDFILIAL  ) AND
				(VE.CDCAIXA    = :CDCAIXA   ) AND
				(VE.NRSEQVENDA = :NRSEQVENDA)
	";

	const GET_CANCELED_PRODUCTS = "
		SELECT
			IC.CDFILIAL, IC.CDCAIXA, IC.NRSEQVENDA, IC.NRSEQITVENDC,
			IC.QTPRODVENDC, IC.CDPRODUTO, PR.NMPRODUTO,  PR.SGUNIDADE
		FROM
			ITVENDACAN IC
		JOIN PRODUTO PR
			ON IC.CDPRODUTO  = PR.CDPRODUTO
		WHERE
			IC.CDFILIAL   = :CDFILIAL
			AND IC.CDCAIXA    = :CDCAIXA
			AND IC.NRSEQVENDA = :NRSEQVENDA
	";

	const BUSCA_DADOS_IMPRESSORA = "
        SELECT P.NRSEQIMPRLOJA, I.IDMODEIMPRES, P.CDPORTAIMPR, L.CDLOJA, UPPER(L.NMLOJA) AS NMLOJA, UPPER(C.NMCAIXA) AS NMCAIXA
          FROM CAIXA C JOIN IMPRLOJA P
                         ON C.CDFILIAL = P.CDFILIAL
                        AND C.CDLOJA = P.CDLOJA
                        AND C.NRSEQIMPRLOJA3 = P.NRSEQIMPRLOJA
                       JOIN IMPRESSORA I
                         ON P.CDIMPRESSORA = I.CDIMPRESSORA
                       JOIN LOJA L
                         ON L.CDLOJA = C.CDLOJA
                        AND L.CDFILIAL = C.CDFILIAL
         WHERE C.CDFILIAL = :CDFILIAL
           AND C.CDCAIXA = :CDCAIXA
           AND C.NRORG = :NRORG
    ";
}