<?php

namespace Odhen\API\Service;

class Operador {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

	public function buscaControleAcesso($CDOPERADOR) {
		$params = array(
			'CDOPERADOR' => $CDOPERADOR
		);
		$supervisor = $this->entityManager->getConnection()->fetchAll(self::SQL_VALIDA_SUPERVISOR, $params);
		if (!empty($supervisor)) {
			$operadorSupervisor = 'S';
		} else {
			$operadorSupervisor = 'N';
		}

		$params = array(
			'CDOPERADOR' => $CDOPERADOR
		);
		$controleAcesso = $this->entityManager->getConnection()->fetchAll(self::SQL_CONTROLE_ACESSO, $params);
		if (!empty($controleAcesso)) {
			$arrayControle = self::constroiControleAcesso($controleAcesso);
			$result = array(
				'error' => false,
				'controleAcesso' => $arrayControle,
				'operadorSupervisor' => $operadorSupervisor
			);
		} else {
			$result = array(
				'error' => true,
				'message' => 'Controle de acesso não encontrado para o operador.'
			);
		}
		return $result;
	}

    const SQL_VALIDA_SUPERVISOR = "
        SELECT CDOPERADOR
          FROM OPERGRUPOP
         WHERE CDOPERADOR = :CDOPERADOR
           AND CDGRUPOPER IN (SELECT CDGRUPOPER
                                FROM AUTGRUPOP
                               WHERE IDAUTGRUPOP = 'SFOS')
    ";        

	const SQL_CONTROLE_ACESSO = "
        SELECT OP.CDOPERADOR, GP.CDGRUPOPER, GP.DSSENHACAIXA
          FROM GRUPOPER GP, OPERGRUPOP OP
         WHERE OP.CDOPERADOR = :CDOPERADOR
           AND GP.CDGRUPOPER = OP.CDGRUPOPER
    ";

    private  function constroiControleAcesso($controleAcesso) {
        /*
		{' 1|Trocar Operador'}
		{' 2|Devolução Item'}
		{' 3|Cancela Cupom'}
		{' 4|Cancela Último Item'}
		{' 5|Cancela Item Genérico'}
		{' 6|Cancela Mesa/Comanda'}
		{' 7|Consulta Saldo'}
		{' 8|Cupom com Desconto'}
		{' 9|Produto Combinado'}
		{'10|Consulta Preço'}
		{'11|Relatórios Fiscais'}
		{'12|Administração TEF'}
		{'13|Sangria'}
		{'14|Suprimento'}
		{'15|Leitura X'}
		{'16|Redução Z'}
		{'17|Abrir Gaveta'}
		{'18|Observação do Pedido'}
		{'19|Fechar Caixa'}
		{'20|Bloquear Caixa'}
		{'21|Liberar Mesa'}
		{'22|Retirar Consumação'}
		{'23|Retirar Couvert'}
		{'24|Retirar Taxa de Serviço'}
		{'25|Agrupar Mesas'}
		{'26|Cancelar Agrupamento/Separar Mesa'}
		{'27|Transferir Mesa'}
		{'28|Transferir Produto'}
		{'29|Relatório de Produtos'}
		{'30|Pesquisar Produtos'}
		{'31|Importar Dados'}
		{'32|Posicao Mesa'}
		{'33|Reservar Mesa'}
		{'34|Alterar Nr. Pessoas'}
		{'35|Parcial Conta'}
		{'36|Abertura do caixa'}
		*/

		$trocarOperador = 'N';
		$devolucaoItem = 'N';
		$cancelaCupom = 'N';
		$cancelaUltimoItem = 'N';
		$cancelaItemGenerico = 'N';
		$cancelaMesaComanda = 'N';
		$consultaSaldo = 'N';
		$cupomDesconto = 'N';
		$produtoCombinado = 'N';
		$consultaPreco = 'N';
		$relatoriosFiscais = 'N';
		$administracaoTEF = 'N';
		$sangria = 'N';
		$suprimento = 'N';
		$leituraX = 'N';
		$reducaoZ = 'N';
		$abrirGaveta = 'N';
		$observacaoPedido = 'N';
		$fecharCaixa = 'N';
		$bloquearCaixa = 'N';
		$liberarMesa = 'N';
		$retirarConsumacao = 'N';
		$retirarCouvert = 'N';
		$retirarTaxaServico = 'N';
		$agruparMesas = 'N';
		$cancelarAgrupamento = 'N';
		$transferirMesa = 'N';
		$transferirProduto = 'N';
		$relatorioProdutos = 'N';
		$pesquisarProdutos = 'N';
		$importarDados = 'N';
		$posicaoMesa = 'N';
		$reservarMesa = 'N';
		$alterarQtPessoas = 'N';
		$parcialConta = 'N';
		$aberturaCaixa  = 'N';

        foreach ($controleAcesso as $item) {
            if ($trocarOperador != 'S') {
                if ($trocarOperador != 'C') {
                    $trocarOperador = substr($item['DSSENHACAIXA'], 0, 1);
                }
            }
            if ($devolucaoItem != 'S') {
                if ($devolucaoItem != 'C') {
                    $devolucaoItem = substr($item['DSSENHACAIXA'], 1, 1);
                }
            }
            if ($cancelaCupom != 'S') {
                if ($cancelaCupom != 'C') {
                    $cancelaCupom = substr($item['DSSENHACAIXA'], 2, 1);
                }
            }
            if ($cancelaUltimoItem != 'S') {
                if ($cancelaUltimoItem != 'C') {
                    $cancelaUltimoItem = substr($item['DSSENHACAIXA'], 3, 1);
                }
            }
            if ($cancelaItemGenerico != 'S') {
                if ($cancelaItemGenerico != 'C') {
                    $cancelaItemGenerico = substr($item['DSSENHACAIXA'], 4, 1);
                }
            }
            if ($cancelaMesaComanda != 'S') {
                if ($cancelaMesaComanda != 'C') {
                    $cancelaMesaComanda = substr($item['DSSENHACAIXA'], 5, 1);
                }
            }
            if ($consultaSaldo != 'S') {
                if ($consultaSaldo != 'C') {
                    $consultaSaldo = substr($item['DSSENHACAIXA'], 6, 1);
                }
            }
            if ($cupomDesconto != 'S') {
                if ($cupomDesconto != 'C') {
                    $cupomDesconto = substr($item['DSSENHACAIXA'], 7, 1);
                }
            }
            if ($produtoCombinado != 'S') {
                if ($produtoCombinado != 'C') {
                    $produtoCombinado = substr($item['DSSENHACAIXA'], 8, 1);
                }
            }
            if ($consultaPreco != 'S') {
                if ($consultaPreco != 'C') {
                    $consultaPreco = substr($item['DSSENHACAIXA'], 9, 1);
                }
            }
            if ($relatoriosFiscais != 'S') {
                if ($relatoriosFiscais != 'C') {
                    $relatoriosFiscais = substr($item['DSSENHACAIXA'], 10, 1);
                }
            }
            if ($administracaoTEF != 'S') {
                if ($administracaoTEF != 'C') {
                    $administracaoTEF = substr($item['DSSENHACAIXA'], 11, 1);
                }
            }
            if ($sangria != 'S') {
                if ($sangria != 'C') {
                    $sangria = substr($item['DSSENHACAIXA'], 12, 1);
                }
            }
            if ($suprimento != 'S') {
                if ($suprimento != 'C') {
                    $suprimento = substr($item['DSSENHACAIXA'], 13, 1);
                }
            }
            if ($leituraX != 'S') {
                if ($leituraX != 'C') {
                    $leituraX = substr($item['DSSENHACAIXA'], 14, 1);
                }
            }
            if ($reducaoZ != 'S') {
                if ($reducaoZ != 'C') {
                    $reducaoZ = substr($item['DSSENHACAIXA'], 15, 1);
                }
            }
            if ($abrirGaveta != 'S') {
                if ($abrirGaveta != 'C') {
                    $abrirGaveta = substr($item['DSSENHACAIXA'], 16, 1);
                }
            }
            if ($observacaoPedido != 'S') {
                if ($observacaoPedido != 'C') {
                    $observacaoPedido = substr($item['DSSENHACAIXA'], 17, 1);
                }
            }
            if ($fecharCaixa != 'S') {
                if ($fecharCaixa != 'C') {
                    $fecharCaixa = substr($item['DSSENHACAIXA'], 18, 1);
                }
            }
            if ($bloquearCaixa != 'S') {
                if ($bloquearCaixa != 'C') {
                    $bloquearCaixa = substr($item['DSSENHACAIXA'], 19, 1);
                }
            }
            if ($liberarMesa != 'S') {
                if ($liberarMesa != 'C') {
                    $liberarMesa = substr($item['DSSENHACAIXA'], 20, 1);
                }
            }
            if ($retirarConsumacao != 'S') {
                if ($retirarConsumacao != 'C') {
                    $retirarConsumacao = substr($item['DSSENHACAIXA'], 21, 1);
                }
            }
            if ($retirarCouvert != 'S') {
                if ($retirarCouvert != 'C') {
                    $retirarCouvert = substr($item['DSSENHACAIXA'], 22, 1);
                }
            }

            if ($retirarTaxaServico != 'S') {
                if ($retirarTaxaServico != 'C') {
                    $retirarTaxaServico = substr($item['DSSENHACAIXA'], 23, 1);
                }
            }

            if ($agruparMesas != 'S') {
                if ($agruparMesas != 'C') {
                    $agruparMesas = substr($item['DSSENHACAIXA'], 24, 1);
                }
            }

            if ($cancelarAgrupamento != 'S') {
                if ($cancelarAgrupamento != 'C') {
                    $cancelarAgrupamento = substr($item['DSSENHACAIXA'], 25, 1);
                }
            }

            if ($transferirMesa != 'S') {
                if ($transferirMesa != 'C') {
                    $transferirMesa = substr($item['DSSENHACAIXA'], 26, 1);
                }
            }

            if ($transferirProduto != 'S') {
                if ($transferirProduto != 'C') {
                    $transferirProduto = substr($item['DSSENHACAIXA'], 27, 1);
                }
            }

            if ($relatorioProdutos != 'S') {
                if ($relatorioProdutos != 'C') {
                    $relatorioProdutos = substr($item['DSSENHACAIXA'], 28, 1);
                }
            }
            if ($pesquisarProdutos != 'S') {
                if ($pesquisarProdutos != 'C') {
                    $pesquisarProdutos = substr($item['DSSENHACAIXA'], 29, 1);
                }
            }
            if ($importarDados != 'S') {
                if ($importarDados != 'C') {
                    $importarDados = substr($item['DSSENHACAIXA'], 30, 1);
                }
            }
            if ($posicaoMesa != 'S') {
                if ($posicaoMesa != 'C') {
                    $posicaoMesa = substr($item['DSSENHACAIXA'], 31, 1);
                }
            }
            if ($reservarMesa != 'S') {
                if ($reservarMesa != 'C') {
                    $reservarMesa = substr($item['DSSENHACAIXA'], 32, 1);
                }
            }
            if ($alterarQtPessoas != 'S') {
                if ($alterarQtPessoas != 'C') {
                    $alterarQtPessoas = substr($item['DSSENHACAIXA'], 33, 1);
                }
            }
            if ($parcialConta != 'S') {
                if ($parcialConta != 'C') {
                    $parcialConta = substr($item['DSSENHACAIXA'], 34, 1);
                }
            }
            if ($aberturaCaixa != 'S') {
                if ($aberturaCaixa != 'C') {
                    $aberturaCaixa = substr($item['DSSENHACAIXA'], 35, 1);
                }
            }
        }

        return array(
            'trocarOperador' => $trocarOperador,
            'devolucaoItem' => $devolucaoItem,
            'cancelaCupom' => $cancelaCupom,
            'cancelaUltimoItem' => $cancelaUltimoItem,
            'cancelaItemGenerico' => $cancelaItemGenerico,
            'cancelaMesaComanda' => $cancelaMesaComanda,
            'consultaSaldo' => $consultaSaldo,
            'cupomDesconto' => $cupomDesconto,
            'produtoCombinado' => $produtoCombinado,
            'consultaPreco' => $consultaPreco,
            'relatoriosFiscais' => $relatoriosFiscais,
            'administracaoTEF' => $administracaoTEF,
            'sangria' => $sangria,
            'suprimento' => $suprimento,
            'leituraX' => $leituraX,
            'reducaoZ' => $reducaoZ,
            'abrirGaveta' => $abrirGaveta,
            'observacaoPedido' => $observacaoPedido,
            'fecharCaixa' => $fecharCaixa,
            'bloquearCaixa' => $bloquearCaixa,
            'liberarMesa' => $liberarMesa,
            'retirarConsumacao' => $retirarConsumacao,
            'retirarCouvert' => $retirarCouvert,
            'retirarTaxaServico' => $retirarTaxaServico,
            'agruparMesas' => $agruparMesas,
            'cancelarAgrupamento' => $cancelarAgrupamento,
            'transferirMesa' => $transferirMesa,
            'transferirProduto' => $transferirProduto,
            'relatorioProdutos' => $relatorioProdutos,
            'pesquisarProdutos' => $pesquisarProdutos,
            'importarDados' => $importarDados,
            'posicaoMesa' => $posicaoMesa,
            'reservarMesa' => $reservarMesa,
            'alterarQtPessoas' => $alterarQtPessoas,
            'parcialConta' => $parcialConta,
            'aberturaCaixa' => $aberturaCaixa
        );
    }

}