<?php

namespace Zeedhi\PaymentPlatform\examples;

$ds = DIRECTORY_SEPARATOR;

require_once __DIR__.$ds.'..'.$ds.'..'.$ds.'vendor'.$ds.'autoload.php';

use Zeedhi\PaymentPlatform\Implementations\MundiPagg\PaymentImpl;
$paymentPlatform = PaymentImpl::factory("sk_test_kVe4L0yCEcEW4Nb9");

use Zeedhi\PaymentPlatform\Revoke\RevokePlatform;
use Zeedhi\PaymentPlatform\Revoke\Revoke;

use Zeedhi\PaymentPlatform\RequestURL;

class Order {

    private $paymentPlatform;

    public function __construct(RevokePlatform $paymentPlatform) {
        $this->paymentPlatform = $paymentPlatform;
    }
    
    public function revoke(Revoke $revoke){
        return $this->paymentPlatform->revoke($revoke);
    }

}

/**.
 * Os registros passíveis de revogação:
 * transações - RequestURL::MUNDIPAGG_CHARGES. 
 * Obs.: É possível cancelar apenas determinado valor de uma transação, basta passar como terceiro paramentro. (Ex.: new Revoke($id, $baseURL, '1000.00')).
 */
$id = "ch_BQXawy5UOZc5v18p";
$baseURL = RequestURL::MUNDIPAGG_CHARGES;
$revoke = new Revoke($id, $baseURL);

$order = new Order($paymentPlatform);
$transactionId = $order->revoke($revoke);
var_dump($transactionId);

