<?php
namespace Zeedhi\PaymentPlatform\BankSlip;

use Zeedhi\PaymentPlatform\Address;

class Store{

    /** @var string */
    private $fancyName;
    /** @var Address */
    private $storeAddress;
    /** @var StoreBankAccount */
    private $storeBank;
    /** @var string */
    private $webSite;
    /** @var string */
    private $cpfCnpj;
    /** @var string */
    private $businessName;
    /** @var string */
    private $agreement;
    /** @var string */
    private $contract;
    

    /**
     * @params string           $fancyName
     * @params Address          $storeAddress
     * @params StoreBankAccount $storeBank
     * @params string           $webSite
     * @params string           $cpfCnpj
     * @params string           $businessName
     * @params string           $agreement
     * @params string           $contract
     */
    public function __construct($fancyName, Address $storeAddress, StoreBankAccount $storeBank, $webSite, $cpfCnpj, $businessName, $agreement = null, $contract = null){
        $this->fancyName = $fancyName;
        $this->storeAddress = $storeAddress;
        $this->storeBank = $storeBank;
        $this->webSite = $webSite;
        $this->cpfCnpj = $cpfCnpj;
        $this->businessName = $businessName;
        $this->agreement = $agreement;
        $this->contract = $contract;
    }
    
    /**
     * @return string
     */
    public function getFancyName(){
        return $this->fancyName;
    }
    
    /**
     * @return Address
     */
    public function getStoreAddress(){
        return $this->storeAddress;
    }
    
    /**
     * @return StoreBankAccount
     */
    public function getStoreBank(){
        return $this->storeBank;
    }
    
    /**
     * @return string
     */
    public function getWebSite(){
        return $this->webSite;
    }
    
    /**
     * @return string
     */
    public function getCpfCnpj(){
        return $this->cpfCnpj;
    }
    
    /**
     * @return string
     */
    public function getBusinessName(){
        return $this->businessName;
    }
    
    /**
     * @return string
     */
    public function getAgreement(){
        return $this->agreement;
    }
    
    /**
     * @return string
     */
    public function getContract(){
        return $this->contract;
    }
    
}