<?php

namespace Zeedhi\PaymentPlatform\examples;

$ds = DIRECTORY_SEPARATOR;

require_once __DIR__.$ds.'..'.$ds.'..'.$ds.'vendor'.$ds.'autoload.php';

use Zeedhi\PaymentPlatform\Implementations\MundiPagg\PaymentImpl;
$paymentPlatform = PaymentImpl::factory("sk_test_kVe4L0yCEcEW4Nb9");

use Zeedhi\PaymentPlatform\Consult\ConsultPlatform;
use Zeedhi\PaymentPlatform\Consult\Consult;

use Zeedhi\PaymentPlatform\RequestURL;

class Order {

    private $paymentPlatform;

    public function __construct(ConsultPlatform $paymentPlatform) {
        $this->paymentPlatform = $paymentPlatform;
    }
    
    public function consult(Consult $consult){
        return $this->paymentPlatform->consult($consult);
    }

}


/**
 * Consult
 * Os registros passíveis de consulta são:
 * clientes - RequestURL::MUNDIPAGG_CUSTOMERS
 * transações - RequestURL::MUNDIPAGG_CHARGES
 */
$id = "ch_BQXawy5UOZc5v18p";
$baseURL = RequestURL::MUNDIPAGG_CHARGES;
$consult = new Consult($id, $baseURL);

$order = new Order($paymentPlatform);
$transactionId = $order->consult($consult);
var_dump($transactionId);

