<?php
namespace Zeedhi\PaymentPlatform;

use Zeedhi\PaymentPlatform\Address;

class CustomerTest extends \PHPUnit_Framework_TestCase {
    
    /** @var Customer */
    protected $customer;
    /** @var String */
    protected $id = '1';
    /** @var String */
    protected $name = "Teste Teknisa";
    /** @var Address */
    protected $address;
    /** @var String */
    protected $document = "000001";
    /** @var String */
    protected $email = "teknisa@teste.com";
    /** @var String */
    protected $phone = "33333333";
    /** @var String */
    protected $type = "individual";
    
    public function setUp(){
        $this->address = $this->getMockBuilder(Address::class)
                            ->setMethods(array())
                            ->disableOriginalConstructor()
                            ->getMock();
                            
        $this->customer = new Customer;
        $this->customer->setId($this->id);
        $this->customer->setName($this->name);
        $this->customer->setAddress($this->address);
        $this->customer->setDocument($this->document);
        $this->customer->setEmail($this->email);
        $this->customer->setPhone($this->phone);
        $this->customer->setType($this->type);
    }
    
        
    public function testGetId(){
        $this->assertEquals($this->id, $this->customer->getId());
    }

    public function testGetName(){
        $this->assertEquals($this->name, $this->customer->getName());
    }
    
    public function testGetAddress(){
        $this->assertEquals($this->address, $this->customer->getAddress());
    }
    
    public function testGetDocument(){
        $this->assertEquals($this->document, $this->customer->getDocument());
    }
    
    public function testGetEmail(){
        $this->assertEquals($this->email, $this->customer->getEmail());
    }
    
    public function testGetPhone(){
        $this->assertEquals($this->phone, $this->customer->getPhone());
    }

    public function testGetType(){
        $this->assertEquals($this->type, $this->customer->getType());
    }
}