describe("SelectController", function(){

    var selectController;
    var scopeMock;
    window.templateUrls = [{
        package: "default",
        baseUrl: ""
    }];
    var $injector = {
        get: function(dependencyName) {
            var dependency;
            switch (dependencyName) {
                case "ApplicationContext":
                dependency = {
                    reportsRepository: reportsRepository
                };
                break;
                default:
                dependency = {};
                break;
            }
            return {};
        }
    };

    beforeEach(function() {
        module("ZeedhiApp");
        inject(function($rootScope, $window, $controller) {
            var screenService = ScreenService;
            var templateManagerMock = {
                project: {},
                getFrameworkTemplateURL: function(template) {
                    return 'templates/' + template;
                }
            };

            scopeMock = $rootScope.$new();
            scopeMock.field = {};
            scopeMock.widget = {
                showCheckbox: true,
                searchList: {},
                getActionsByVisibility: function() {
                    return [];
                },
                getDataSourceFilter: function() {
                    return [];
                },
                actions: [],
                fields: [
                {
                    'name': 'field',
                }
                ],
                container: {
                    actions: []
                },
                dataSourceFilter: []
            };

            selectController = $controller("SelectController", {
                $scope: scopeMock,
                templateManager: templateManagerMock,
                ScreenService: {
                    i18n: function(word) {return word;}
                },
                ZhUtil: {
                    getOrderByFilter: function() {
                        return [];
                    }
                },
                SelectService: {},
                ZHPromise: {},
                maskEngine: {
                    getMappedMasks: function () {
                        var mappedMasks = {
                            fix: {
                                format: function (value) {
                                    expect(value).toBe('123');
                                    return '12.3';
                                }
                            }
                        };

                        return mappedMasks;
                    }
                },
                EventChildPropagation: {}
            });
        });
    });

    it("Should return value without mask", function() {
        expect(selectController.getSelectionText('123')).toBe('123');
    });

    it("Should return value with mask", function () {
        scopeMock.field = {
            mask: {
                type: 'fix',
                params: {
                    format: '99.9'
                }
            }
        };
        expect(selectController.getSelectionText('123')).toBe('12.3');
    });
});